*************************************************************************
*    File:	gpImage.prg
* Version:	1.6
* Created:	12.09.2002
*Modified:	09.11.2003
*  Author:	Alexander Golovlev
* Country:	Russian Federation
*   Email:	golovlev@yandex.ru
*************************************************************************

*************************************************************************
*    File:	gpImage.prg
* Version:	1.68
* Created:	12.09.2002
*Modified:	05.22.2005 by Cesar Chalom
* Country:	Brazil
*   Email:	cchalom@hotmail.com
*
*   Notes:  Added GRAPHICS CLASS functions under the authorization of Alexander Golovlev
*			Great information about GDIPLUS can be found at
*			http://www.bobpowell.net/, from where I got valuable information
*************************************************************************

#include gpImage.h

*-- Error messages
#define ERR_MODULE		"Cannot load a module "
#define ERR_PICTYPE		"Unsupported picture type"
#define ERR_CLIPNOTOPEN	"Cannot open the clipboard"
#define ERR_CLIPNODATA	"No bitmap data found on the clipboard"
#define ERR_CLIPSETDATA	"Cannot place data on the clipboard"

*-- Constants
#define MAX_PATH	260
#define LPTR		0x0040
#define SRCCOPY		13369376
#define CRLF		Chr(13) + Chr(10)
#define VT_DISPATCH	9
#define IID_IDispatch Chr(0x00)+Chr(0x04)+Chr(0x02)+Chr(0x00)+ ;
		Replicate(Chr(0x00), 4)+Chr(0xC0)+Replicate(Chr(0x00), 6)+Chr(0x46)

*-- Picture Types
#define PICTYPE_UNINITIALIZED	(-1)
#define PICTYPE_NONE			0
#define PICTYPE_BITMAP			1
#define PICTYPE_METAFILE		2
#define PICTYPE_ICON			3
#define PICTYPE_ENHMETAFILE		4 

*-- Predefined Clipboard Formats
#define CF_BITMAP				2
#define CF_PALETTE				9
#define OBJ_BITMAP				7

*-- Encoder CLSIDs
#define CLSID_BMP				"{557CF400-1A04-11D3-9A73-0000F81EF32E}"
#define CLSID_JPEG				"{557CF401-1A04-11D3-9A73-0000F81EF32E}"
#define CLSID_GIF				"{557CF402-1A04-11D3-9A73-0000F81EF32E}"
#define CLSID_TIFF				"{557CF405-1A04-11D3-9A73-0000F81EF32E}"
#define CLSID_PNG				"{557CF406-1A04-11D3-9A73-0000F81EF32E}"

*-- Encoder parameter sets
#define GUID_Compress			"{e09d739d-ccd4-44ee-8eba-3fbf8be4fc58}"
#define GUID_ColorDepth			"{66087055-ad66-4c7c-9a18-38a2310b8337}"
#define GUID_Quality			"{1d5be4b5-fa4a-452d-9cdd-5db35105e7eb}"
#define GUID_Transform			"{8d0eb2d1-a58e-4ea8-aa14-108074b7b6f9}"
#define GUID_SaveFlag			"{292266fc-ac40-47bf-8cfc-a85b89a655de}"

*-- Predefined multi-frame dimension IDs
#define GUID_Time				"{6aedbd6d-3fb5-418a-83a6-7f45229dc872}"
#define GUID_Page				"{7462dc86-6180-4c7e-8e3f-ee7333a7a483}"

*-- Image file format identifiers
#define GUID_FormatUndefined	"{b96b3ca9-0728-11d3-9d7b-0000f81ef32e}"
#define GUID_FormatMemoryBMP	"{b96b3caa-0728-11d3-9d7b-0000f81ef32e}"
#define GUID_FormatBMP			"{b96b3cab-0728-11d3-9d7b-0000f81ef32e}"
#define GUID_FormatEMF			"{b96b3cac-0728-11d3-9d7b-0000f81ef32e}"
#define GUID_FormatWMF			"{b96b3cad-0728-11d3-9d7b-0000f81ef32e}"
#define GUID_FormatJPEG			"{b96b3cae-0728-11d3-9d7b-0000f81ef32e}"
#define GUID_FormatPNG			"{b96b3caf-0728-11d3-9d7b-0000f81ef32e}"
#define GUID_FormatGIF			"{b96b3cb0-0728-11d3-9d7b-0000f81ef32e}"
#define GUID_FormatTIFF			"{b96b3cb1-0728-11d3-9d7b-0000f81ef32e}"
#define GUID_FormatEXIF			"{b96b3cb2-0728-11d3-9d7b-0000f81ef32e}"
#define GUID_FormatIcon			"{b96b3cb5-0728-11d3-9d7b-0000f81ef32e}"

*-- Pixel Formats
#define	PixelFormatIndexed		0x00010000	&& Indexes into a palette
#define	PixelFormatGDI			0x00020000	&& Is a GDI-supported format
#define	PixelFormatAlpha		0x00040000	&& Has an alpha component
#define	PixelFormatPAlpha		0x00080000	&& Pre-multiplied alpha
#define	PixelFormatExtended		0x00100000	&& Extended color 16 bits/channel
#define	PixelFormatCanonical	0x00200000

#define	PixelFormat1bppIndexed		( 1 + ( 1 * 256) + PixelFormatIndexed + PixelFormatGDI)
#define	PixelFormat4bppIndexed		( 2 + ( 4 * 256) + PixelFormatIndexed + PixelFormatGDI)
#define	PixelFormat8bppIndexed		( 3 + ( 8 * 256) + PixelFormatIndexed + PixelFormatGDI)
#define	PixelFormat16bppGrayScale	( 4 + (16 * 256) + PixelFormatExtended)
#define	PixelFormat16bppRGB555		( 5 + (16 * 256) + PixelFormatGDI)
#define	PixelFormat16bppRGB565		( 6 + (16 * 256) + PixelFormatGDI)
#define	PixelFormat16bppARGB1555	( 7 + (16 * 256) + PixelFormatAlpha + PixelFormatGDI)
#define	PixelFormat24bppRGB			( 8 + (24 * 256) + PixelFormatGDI)
#define	PixelFormat32bppRGB			( 9 + (32 * 256) + PixelFormatGDI)
#define	PixelFormat32bppARGB		(10 + (32 * 256) + PixelFormatAlpha + PixelFormatGDI + PixelFormatCanonical)
#define	PixelFormat32bppPARGB		(11 + (32 * 256) + PixelFormatAlpha + PixelFormatPAlpha + PixelFormatGDI)
#define	PixelFormat48bppRGB			(12 + (48 * 256) + PixelFormatExtended)
#define	PixelFormat64bppARGB		(13 + (64 * 256) + PixelFormatAlpha + PixelFormatCanonical + PixelFormatExtended)
#define	PixelFormat64bppPARGB		(14 + (64 * 256) + PixelFormatAlpha + PixelFormatPAlpha + PixelFormatExtended)

*--	FontStyle: face types and common styles
#DEFINE GDIPLUS_FontStyle_Regular     0
#DEFINE GDIPLUS_FontStyle_Bold        1
#DEFINE GDIPLUS_FontStyle_Italic      2
#DEFINE GDIPLUS_FontStyle_BoldItalic  3
#DEFINE GDIPLUS_FontStyle_Underline   4
#DEFINE GDIPLUS_FontStyle_Strikeout   8

***********************************************************************
*   Class:	gpInit
***********************************************************************

Define Class gpInit as Custom
	Protected gdiplusToken

	gdiplusToken = 0

	Protected Procedure Init(tcFileName)
		Declare Long PathFindOnPath in Shlwapi.dll String @ pszFile, Long ppszOtherDirs
		Declare Long UuidFromString in rpcrt4.dll String StringUuid, String @ Uuid

		Declare Long LocalAlloc in Win32API Long uFlags, Long uBytes
		Declare Long LocalFree in Win32API Long hMem
		Declare Long LoadLibrary in Win32API String FileName
		Declare Long FreeLibrary in Win32API Long hModule

		Declare Long GdiplusStartup in GdiPlus.dll ;
			Long @ token, String @ input, Long @ output
		Declare Long GdiplusShutdown in GdiPlus.dll ;
			Long token
		Declare Long GdipLoadImageFromFile in GdiPlus.dll ;
			String FileName, Long @ GpImage
		Declare Long GdipSaveImageToFile in GdiPlus.dll ;
			Long GpImage, String FileName, String @ encoderClsid, String @ encoderParams
		Declare Long GdipSaveAddImage in GdiPlus.dll ;
			Long GpImage, Long newImage, String @ encoderParams
		Declare Long GdipCreateBitmapFromScan0 in GdiPlus.dll ;
			Integer width, Integer height, Integer stride, Long format, Long scan0, Long @ bitmap
		Declare Long GdipCreateBitmapFromResource in GdiPlus.dll ;
			Long hInstance, String bitmapName, Long @ bitmap
		Declare Long GdipCreateBitmapFromHBITMAP in GdiPlus.dll ;
			Long hbm, Long hpal, Long @ bitmap
		Declare Long GdipCreateBitmapFromHICON in GdiPlus.dll ;
			Long hicon, Long @ bitmap
		Declare Long GdipCreateMetafileFromWmf in GdiPlus.dll ;
			Long hWmf, Long deleteWmf, Long wmfPlaceableFileHeader, Long @ metafile
		Declare Long GdipCreateMetafileFromEmf in GdiPlus.dll ;
			Long hEmf, Long deleteEmf, Long @ metafile
		Declare Long GdipCreateHBITMAPFromBitmap in GdiPlus.dll ;
			Long nativeImage, Long @ hbmReturn, Long argb
		Declare Long GdipCreateHICONFromBitmap in GdiPlus.dll ;
			Long nativeImage, Long @ hbmReturn
		Declare Long GdipGetImageRawFormat in GdiPlus.dll ;
			Long nativeImage, String @ RawFormat
		Declare Long GdipGetImagePixelFormat in GdiPlus.dll ;
			Long nativeImage, Long @ PixelFormat
		Declare Long GdipGetImageWidth in GdiPlus.dll ;
			Long nativeImage, Long @ width
		Declare Long GdipGetImageHeight in GdiPlus.dll ;
			Long nativeImage, Long @ height
		Declare Long GdipGetImageThumbnail in GdiPlus.dll ;
			Long nativeImage, Long thumbWidth, Long thumbHeight, Long @ thumbimage, ;
			Long callback, Long callbackData
		Declare Long GdipDisposeImage in GdiPlus.dll ;
			Long GpImage

		Declare Long GdipBitmapGetPixel in GdiPlus.dll ;
			Long nativeImage, Long x, Long y, Long @ argb
		Declare Long GdipBitmapSetPixel in GdiPlus.dll ;
			Long nativeImage, Long x, Long y, Long argb
		Declare Long GdipGetImageHorizontalResolution in GdiPlus.dll ;
			Long nativeImage, Single @ resolution
		Declare Long GdipGetImageVerticalResolution in GdiPlus.dll ;
			Long nativeImage, Single @ resolution
		Declare Long GdipBitmapSetResolution in GdiPlus.dll ;
			Long nativeImage, Single xdpi, Single ydpi
		Declare Long GdipCloneImage in GdiPlus.dll ;
			Long nativeImage, Long @ cloneBitmap
		Declare Long GdipCloneBitmapAreaI in GdiPlus.dll ;
			Long x, Long y, Long width, Long height, ;
			Long format, Long nativeImage, Long @ gpdstBitmap
		Declare Long GdipImageRotateFlip in GdiPlus.dll ;
			Long nativeImage, Long rotateFlipType

		Declare Long GdipGetImageGraphicsContext in GdiPlus.dll ;
			Long image, Long @ graphics
		Declare Long GdipSetInterpolationMode in GdiPlus.dll ;
			Long graphics, Long interpolationMode
		Declare Long GdipDrawImageRectI in GdiPlus.dll ;
			Long graphics, Long image, Integer x, Integer y, Integer width, Integer height

		Declare Long GdipImageGetFrameCount in GdiPlus.dll ;
			Long image, String @ dimensionID, Long @ count
		Declare Long GdipImageSelectActiveFrame in GdiPlus.dll ;
			Long image, String @ dimensionID, Long frameIndex

		Declare Long OpenClipboard in Win32API Long hWnd
		Declare Long CloseClipboard in Win32API
		Declare Long EmptyClipboard in Win32API
		Declare Long GetClipboardData in Win32API Long uFormat
		Declare Long SetClipboardData in Win32API Long uFormat, Long hMem
		Declare Long CopyImage In Win32API Long hImage, Long uType, Long cx, Long cy, Long uFlags
		Declare Long DeleteObject in Win32API Long hObject
		Declare Long GetObjectType in Win32API Long h
 
		Declare Long GetDesktopWindow in Win32API
		Declare Long GetWindowDC in Win32API Long hwnd
		Declare Long GetWindowRect in Win32API Long hwnd, String @ lpRect
		Declare Long CreateCompatibleDC in Win32API Long hdc
		Declare Long CreateCompatibleBitmap in Win32API Long hdc, Long nWidth, Long nHeight
		Declare Long SelectObject in Win32API Long hdc, Long hObject
		Declare Long ReleaseDC in Win32API Long hwnd, Long hdc
		Declare Long DeleteDC in Win32API Long hdc
		Declare Long BitBlt in Win32API ;
			Long hDestDC, Long x, Long y, Long nWidth, Long nHeight, ;
			Long hSrcDC, Long xSrc, Long ySrc, Long dwRop
		Declare RtlMoveMemory in Win32API AS RtlCopyLong ;
			Integer @ DestNum, String @ pVoidSource, Integer nLength


*** API DECLARATIONS FOR GRAPHICS CLASS

*!*	GRAPHICS FUNCTIONS

		DECLARE INTEGER GdipCreateFromHWND IN gdiplus.dll ; 
		    INTEGER hWind, INTEGER @graphics  

		DECLARE INTEGER GdipDeleteGraphics IN GdiPlus.dll ;
			INTEGER graphics 

		DECLARE INTEGER GdipTranslateWorldTransform IN GdiPlus.dll ;
			INTEGER graphics, SINGLE dX, SINGLE dY, INTEGER nOrder

		DECLARE INTEGER GdipRotateWorldTransform IN GdiPlus.dll ;
			INTEGER graphics, SINGLE Angle, INTEGER nOrder

		DECLARE INTEGER GdipResetWorldTransform IN GdiPlus.dll ;
			INTEGER graphics

		DECLARE INTEGER GdipDrawString IN GdiPlus.dll; 
			INTEGER graphics, STRING wchar, INTEGER length,; 
			INTEGER fnt, STRING @rectangleF, INTEGER stringFormat, INTEGER brush 

		DECLARE INTEGER GdipMeasureString IN GdiPlus.dll ;
			INTEGER Graphics, STRING wchar, INTEGER length,;
			INTEGER fnt, STRING  rectangleF, INTEGER StringFormat, STRING @boundingBoxRectF, ;
			INTEGER @nCodepointsFitted, INTEGER @nLinesFilled

		DECLARE INTEGER GdipDrawLine IN GdiPlus.dll ;
			INTEGER graphics, INTEGER npen, SINGLE X1, SINGLE Y1, SINGLE X2, SINGLE Y2

		DECLARE GdipDrawRectangle IN GdiPlus.dll; 
			INTEGER graphics, INTEGER npen, SINGLE x, SINGLE y, SINGLE w, SINGLE h

		DECLARE INTEGER GdipFillRectangle IN GdiPlus.dll; 
			INTEGER graphics, INTEGER brush,; 
			SINGLE x, SINGLE y, SINGLE w, SINGLE h 

		DECLARE INTEGER GdipDrawEllipse IN GdiPlus.dll ;
			INTEGER graphics, INTEGER npen, SINGLE x, SINGLE y, SINGLE w, SINGLE h

		DECLARE INTEGER GdipFillEllipse IN GdiPlus.dll ;
			INTEGER graphics, INTEGER brush, SINGLE x, SINGLE y, SINGLE w, SINGLE h

		DECLARE INTEGER GdipDrawPie IN GdiPlus.dll ;
			INTEGER graphics, INTEGER npen, SINGLE x, SINGLE y, SINGLE w, ;
			SINGLE h, SINGLE StartAngle, SINGLE SweepAngle

		DECLARE INTEGER GdipFillPie IN GdiPlus.dll ;
			INTEGER graphics, INTEGER brush, SINGLE x, SINGLE y, SINGLE w, SINGLE h, ;
			SINGLE StartAngle, SINGLE SweepAngle

		DECLARE INTEGER GdipDrawArc IN gdiplus.dll ;
			INTEGER graphics, INTEGER nPen, SINGLE x, SINGLE y, SINGLE w, ;
			SINGLE h, SINGLE StartAngle, SINGLE SweepAngle

		DECLARE INTEGER GdipDrawPolygon IN gdiplus.dll ;
			INTEGER Graphics, INTEGER nPen, STRING PointsF, INTEGER nCount

		DECLARE INTEGER GdipFillPolygon IN gdiplus.dll ;
			INTEGER Graphics, INTEGER Brush, STRING PointsF, INTEGER nCount, INTEGER FillMode

		DECLARE INTEGER GdipDrawImage IN GdiPlus.dll ;
			INTEGER graphics, INTEGER nImage, SINGLE X, SINGLE Y
			
		DECLARE INTEGER GdipDrawImageRect IN GdiPlus.dll ;
			INTEGER graphics, INTEGER nImage, ;
			SINGLE x, SINGLE y, SINGLE w, SINGLE h
			
		DECLARE INTEGER GdipDrawImageRectRect IN gdiplus.dll ;
			INTEGER Graphics, INTEGER nImage, ;
			SINGLE dstx, SINGLE dsty, SINGLE dstwidth, SINGLE dstheight, ;
			SINGLE srcx, SINGLE srcy, SINGLE srcwidth, SINGLE srcheight, ;
			INTEGER srcUnit, INTEGER imageAttributes, ;
			INTEGER Callback, INTEGER CallbackData


*!*	IMAGE ATTRIBUTES
		DECLARE INTEGER GdipCreateImageAttributes IN gdiplus.dll ;
			INTEGER @ImgAttr

		DECLARE INTEGER GdipDisposeImageAttributes IN GdiPlus.dll ;
			INTEGER imageattr

		DECLARE INTEGER GdipResetImageAttributes IN gdiplus.dll ; 
			INTEGER imageattr, INTEGER ColorAdjustType

		DECLARE INTEGER GdipSetImageAttributesColorMatrix IN gdiplus.dll ;
			INTEGER imageattr, ;
			INTEGER ColorAdjustType, ;
			INTEGER enableFlag, ;
			STRING  colorMatrix, ;
			INTEGER grayMatrix, ;
			INTEGER ColorMatrixFlags

		DECLARE INTEGER GdipSetImageAttributesRemapTable IN gdiplus.dll ;
			INTEGER imageattr, ;
			INTEGER ColorAdjustType, ;
			INTEGER enableFlag, ;
			INTEGER mapsize, ;
			STRING  colorMap


*!*	FONT FUNCTIONS
		DECLARE INTEGER GdipCreateFont IN GdiPlus.dll; 
			INTEGER fontFamily, SINGLE emSize,; 
			INTEGER fntstyle, INTEGER unit, INTEGER @fnt 

		DECLARE INTEGER GdipDeleteFont IN GdiPlus.dll ;
			INTEGER fnt 

*!*	FONTFAMILY FUNCTIONS
		DECLARE INTEGER GdipCreateFontFamilyFromName IN GdiPlus.dll; 
			STRING familyname, INTEGER FontCollection, INTEGER @FontFamily 

		DECLARE INTEGER GdipDeleteFontFamily IN GdiPlus.dll ;
			INTEGER FontFamily

*!*	STRING FORMAT FUNCTIONS
		DECLARE INTEGER GdipCreateStringFormat IN GdiPlus.dll ;
		    INTEGER formatAttributes, INTEGER language, INTEGER @nFormat

		DECLARE INTEGER GdipSetStringFormatAlign IN GdiPlus.dll ;
			INTEGER nFormat, INTEGER StringAlignment

		DECLARE INTEGER GdipSetStringFormatLineAlign IN GdiPlus.dll ;
			INTEGER nformat, INTEGER StringAlignment


*!*	PEN FUNCTIONS
		DECLARE INTEGER GdipCreatePen1 IN GdiPlus.dll; 
			INTEGER ARGBcolor, SINGLE penwidth, INTEGER unit, INTEGER @npen 

		DECLARE INTEGER GdipSetPenDashStyle in gdiplus.dll ;
			INTEGER nPen, INTEGER DashStyle

		DECLARE INTEGER GdipDeletePen IN GdiPlus.dll ;
			INTEGER nPen


*!*	BRUSH FUNCTIONS
		DECLARE INTEGER GdipCreateSolidFill IN GdiPlus.dll; 
			INTEGER ARGBcolor, INTEGER @brush 

		DECLARE INTEGER GdipDeleteBrush IN GdiPlus.dll ;
			INTEGER brush

		DECLARE INTEGER GdipCreateHatchBrush IN Gdiplus.dll;
			INTEGER hatchstyle, INTEGER forecol, INTEGER backcol, INTEGER @brush
			
		DECLARE INTEGER GdipCreateTexture IN Gdiplus.dll;
			INTEGER nimage, INTEGER wrapmode, INTEGER @brushTexture

***


#if Version(5) >= 700
		Declare Long OleCreatePictureIndirect In oleaut32 ;
			String @ PicDesc, String @ RefIID, Long fPictureOwnsHandle, Object @ IPic
#else
		Declare Long OleCreatePictureIndirect In oleaut32 ;
			String @ PicDesc, String @ RefIID, Long fPictureOwnsHandle, Long @ IPic
		Declare Long MultiByteToWideChar In kernel32 ;
			Long iCodePage, Long dwFlags, String @ lpStr, Long iMultiByte, ;
			String @ lpWideStr, Long iWideChar 
		Declare Long OleSavePictureFile In oleaut32 Long IPic, Long bstrFile
		Declare Long SysAllocString In oleaut32 String @ szString
		Declare SysFreeString In oleaut32 Long bstr
		Declare Long VariantClear in oleaut32 String @ pvarg
#endif

		Local gdiplusStartupInput, lcToken
	*	struct GdiplusStartupInput
	*	{
	*		UINT32 GdiplusVersion;				// Must be 1
	*		DebugEventProc DebugEventCallback;	// Ignored on free builds
	*		BOOL SuppressBackgroundThread;		// FALSE unless you're prepared to call 
	*											// the hook/unhook functions properly
	*		BOOL SuppressExternalCodecs;		// FALSE unless you want GDI+ only to use
	*											// its internal image codecs.
	*	}
		gdiplusStartupInput = Chr(1) + Replicate(Chr(0), 15)	&& GdiplusStartupInput structure (sizeof = 16)

		* Initialize GDI+.
		lcToken = 0
		If GdiplusStartup(@lcToken, @gdiplusStartupInput, 0) != 0
			Return .F.
		EndIf
		This.gdiplusToken = lcToken
	EndProc

	Protected Procedure Destroy
		GdiplusShutdown(This.gdiplusToken)

#if Version(5) >= 700
		Clear Dlls "PathFindOnPath", "UuidFromString"
		Clear Dlls "LocalAlloc", "LocalFree", "LoadLibrary", "FreeLibrary"
		Clear Dlls "GdiplusStartup", "GdiplusShutdown", ;
			"GdipLoadImageFromFile", "GdipSaveImageToFile", "GdipSaveAddImage", ;
			"GdipCreateBitmapFromScan0", "GdipCreateBitmapFromResource", "GdipCreateBitmapFromHBITMAP", ;
			"GdipCreateBitmapFromHICON", "GdipCreateMetafileFromWmf", "GdipCreateMetafileFromEmf", ;
			"GdipCreateHBITMAPFromBitmap", "GdipCreateHICONFromBitmap"
		Clear Dlls "GdipGetImageRawFormat", "GdipGetImagePixelFormat", ;
			"GdipGetImageWidth", "GdipGetImageHeight", "GdipGetImageThumbnail", "GdipDisposeImage"
		Clear Dlls "GdipBitmapGetPixel", "GdipBitmapSetPixel", "GdipGetImageHorizontalResolution", ;
			"GdipGetImageVerticalResolution", "GdipBitmapSetResolution", "GdipCloneImage", ;
			"GdipCloneBitmapAreaI", "GdipImageRotateFlip"
		Clear Dlls "GdipGetImageGraphicsContext", "GdipSetInterpolationMode", "GdipDrawImageRectI"
		Clear Dlls "GdipImageGetFrameCount", "GdipImageSelectActiveFrame"
		Clear Dlls "OpenClipboard", "CloseClipboard", "EmptyClipboard", "GetClipboardData", "SetClipboardData", ;
			"CopyImage", "DeleteObject", "GetObjectType", "OleCreatePictureIndirect"
		Clear Dlls "GetDesktopWindow", "GetWindowDC", "GetWindowRect", "CreateCompatibleDC", ;
			"CreateCompatibleBitmap", "SelectObject", "ReleaseDC", "DeleteDC", "BitBlt", "RtlMoveMemory"


*** Clearing DLLS used in Graphics class
*!*	GRAPHICS
CLEAR DLLS "GdipCreateFromHWND", "GdipDeleteGraphics", "GdipTranslateWorldTransform", ;
	"GdipRotateWorldTransform", "GdipResetWorldTransform", "GdipDrawString", ;
	"GdipMeasureString", "GdipDrawLine", "GdipDrawRectangle", "GdipFillRectangle", ;
	"GdipDrawEllipse", "GdipFillEllipse", "GdipDrawPie", "GdipFillPie", "GdipDrawArc", ;
	"GdipDrawPolygon", "GdipFillPolygon", "GdipDrawImage", "GdipDrawImageRect", ;
	"GdipDrawImageRectRect"

*!*	FONT FUNCTIONS
CLEAR DLLS "GdipCreateFont", "GdipDeleteFont"

*!*	FONTFAMILY FUNCTIONS
CLEAR DLLS "GdipCreateFontFamilyFromName", "GdipDeleteFontFamily"

*!*	STRING FORMAT FUNCTIONS
CLEAR DLLS "GdipCreateStringFormat", "GdipSetStringFormatAlign", "GdipSetStringFormatLineAlign"

*!*	PEN FUNCTIONS
CLEAR DLLS "GdipCreatePen1", "GdipSetPenDashStyle", "GdipDeletePen"

*!*	BRUSH FUNCTIONS
CLEAR DLLS "GdipCreateSolidFill", "GdipDeleteBrush", "GdipCreateHatchBrush", "GdipCreateTexture"

*!*	IMAGE ATTRIBUTES
CLEAR DLLS "GdipCreateImageAttributes", "GdipDisposeImageAttributes", ;
	"GdipSetImageAttributesColorMatrix", "GdipSetImageAttributesRemapTable", ;
	"GdipResetImageAttributes"
***

#endif
	EndProc

EndDefine


***********************************************************************
*   Class:	gpImage
***********************************************************************

Define Class gpImage as Custom
	Protected stat
	Protected nativeImage

	nativeImage = 0
	ImageFormat = ""
	PixelFormat = ""
	ImageWidth = 0
	ImageHeight = 0
	HorizontalResolution = 0.0
	VerticalResolution = 0.0
	PixelRed   = 0
	PixelGreen = 0
	PixelBlue  = 0


	Protected Procedure Init(tcFileName)
		If !Empty(tcFileName)
			* Create Image object from handle
			If Vartype(tcFileName) = 'N'
				This.nativeImage = tcFileName
				Return
			EndIf

			* Create Image object from file
			If (Vartype(tcFileName) != 'C') or !File(tcFileName)
				Return .F.
			EndIf

			Local lnImage
			lnImage = 0
			This.stat = GdipLoadImageFromFile(This.WideStr(tcFileName), @lnImage)
			If This.stat = 0
				This.nativeImage = lnImage
			EndIf
		EndIf
	EndProc

	PROCEDURE CreateFromGraphics(tnGraphics)
		DECLARE integer GdipGetClipBounds in gdiplus.dll ;
			integer nGraphics, string @ pRectF
		LOCAL lcRectF, lnImage
		lcRectF = replicate(chr(0),16)
		This.Stat = GdipGetClipBounds (tnGraphics, @lcRectF )
		W = float2int(buf2dword(SUBSTR(m.lcRectF,9,4)))
		H = float2int(buf2dword(SUBSTR(m.lcRectF,13,4)))
		DECLARE integer GdipCreateBitmapFromGraphics in gdiplus.dll ;
			integer nWidth, integer nHeight, integer nGraphics, integer @ nImage
		*STORE 100 TO w, h
		*!*	this.Destroy()
		lnImage = 0
		This.Stat = GdipCreateBitmapFromGraphics(m.W, m.H, tnGraphics, @lnImage)
		This.NativeImage = lnImage
	ENDPROC 

	Protected Procedure Destroy
		If This.nativeImage != 0
			GdipDisposeImage(This.nativeImage)
		EndIf
	EndProc

	Procedure Create(tnWidth, tnHeight, tcPixelFormat)
		
		IF VARTYPE(tcPIxelFormat) == "L"
			tcPixelFormat = "32bppARGB"
		ENDIF
		
		IF (Vartype(tnWidth) != 'N') or (Vartype(tnHeight) != 'N')
			Error 11
		ENDIF

		Local newImage, lnFormat
		newImage = 0
		lnFormat = This.StrToPixelFormat(tcPixelFormat)

		This.stat = GdipCreateBitmapFromScan0(tnWidth, tnHeight, 0, lnFormat, 0, @newImage)
		If This.stat = 0
			GdipDisposeImage(This.nativeImage)
			This.nativeImage = newImage
		EndIf
	EndProc

	Procedure Load(tcFileName)
		If Vartype(tcFileName) != 'C'
			Error 11
		EndIf
		If !File(tcFileName)
			Error 1, tcFileName
		EndIf

		Local lnImage
		If This.nativeImage != 0
			GdipDisposeImage(This.nativeImage)
		EndIf
		This.nativeImage = 0

		* Create Image from file
		lnImage = 0
		This.stat = GdipLoadImageFromFile(This.WideStr(tcFileName), @lnImage)
		If This.stat = 0
			This.nativeImage = lnImage
		EndIf
	EndProc

	Procedure FromHBITMAP(thBitmap, thPalette)
		If Vartype(thBitmap) != 'N'
			Error 11
		EndIf
		If !Empty(thPalette) and (Vartype(thPalette) != 'N')
			Error 11
		EndIf
		If Empty(thPalette)
			thPalette = 0
		EndIf

		Local newImage
		If This.nativeImage != 0
			GdipDisposeImage(This.nativeImage)
		EndIf
		This.nativeImage = 0

		newImage = 0
		This.stat = GdipCreateBitmapFromHBITMAP(thBitmap, thPalette, @newImage)
		If This.stat = 0
			This.nativeImage = newImage
		EndIf
	EndProc

	Procedure FromHICON(thIcon)
		If Vartype(thIcon) != 'N'
			Error 11
		EndIf

		Local newImage
		If This.nativeImage != 0
			GdipDisposeImage(This.nativeImage)
		EndIf
		This.nativeImage = 0

		newImage = 0
		This.stat = GdipCreateBitmapFromHICON(thIcon, @newImage)
		If This.stat = 0
			This.nativeImage = newImage
		EndIf
	EndProc

	Procedure GetHBITMAP(tnColor)
		If !Empty(tnColor) and (Vartype(tnColor) != 'N')
			Error 11
		EndIf
		If Empty(tnColor)
			tnColor = 0x00FFFFFF
		EndIf

		Local hBmp, argb
		hBmp = 0
		argb = MakeARGB(tnColor, 255)
		This.stat = GdipCreateHBITMAPFromBitmap(This.nativeImage, @hBmp, argb)
		Return hBmp
	EndProc

	Procedure GetHICON
		Local hIcon
		hIcon = 0
		This.stat = GdipCreateHICONFromBitmap(This.nativeImage, @hIcon)
		Return hIcon
	EndProc

	Procedure FromResource(tcFileName, tcBitmapName)
		If (Vartype(tcFileName) != 'C') or (Vartype(tcBitmapName) != 'C')
			Error 11
		EndIf
		* first parameter is used to return a full qualified path name
		If PathFindOnPath(Padr(tcFileName, MAX_PATH, Chr(0)), 0) = 0
			Error 1, tcFileName
		EndIf

		Local hInstance, bmp
		If This.nativeImage != 0
			GdipDisposeImage(This.nativeImage)
		EndIf
		This.nativeImage = 0

		hInstance = LoadLibrary(tcFileName)
		If hInstance = 0
			Error ERR_MODULE + tcFileName
		endif
		bmp = 0
		This.stat = GdipCreateBitmapFromResource(hInstance, This.WideStr(tcBitmapName), @bmp)
		If This.stat = 0
			This.nativeImage = bmp
		EndIf
		FreeLibrary(hInstance)
	EndProc

	Procedure FromPicture(toPicture)
		If (Vartype(toPicture) != 'O') or (ComClassInfo(toPicture, 5) != '3')
			Error 11
		EndIf

		Local newImage
		If This.nativeImage != 0
			GdipDisposeImage(This.nativeImage)
		EndIf
		This.nativeImage = 0

		newImage = 0
		Do Case
		Case toPicture.Type = PICTYPE_BITMAP
			This.stat = GdipCreateBitmapFromHBITMAP(toPicture.Handle, toPicture.hPal, @newImage)
		Case toPicture.Type = PICTYPE_METAFILE
			This.stat = GdipCreateMetafileFromWmf(toPicture.Handle, 0, 0, @newImage)
		Case toPicture.Type = PICTYPE_ICON
			This.stat = GdipCreateBitmapFromHICON(toPicture.Handle, @newImage)
		Case toPicture.Type = PICTYPE_ENHMETAFILE
			This.stat = GdipCreateMetafileFromEmf(toPicture.Handle, 0, @newImage)
		Otherwise
			Error ERR_PICTYPE
		EndCase 
		If This.stat = 0
			This.nativeImage = newImage
		EndIf
	ENDPROC
	
	Function GetPicture()
		Local hBmp, PictDesc, IPic
		hBmp = 0
		This.stat = GdipCreateHBITMAPFromBitmap(This.nativeImage, @hBmp, 0xFFFFFFFF)
		If This.stat = 0
			* Create Picture object according to PICTDESC structure
			PictDesc = DWord(16) ;				&& Size of PICTDESC structure
					 + DWord(PICTYPE_BITMAP) ;	&& Type of picture
					 + DWord(hBmp) ;			&& HBITMAP
					 + DWord(0)					&& HPALETTE
			iid = IID_IDispatch
			IPic = 0
			OleCreatePictureIndirect(@PictDesc, @iid, 1, @IPic)
#if Version(5) >= 700
			Return IPic
#else
			Local lcTmpFile, lnBstr, lcVar, loPic
			lcTmpFile = "tmp.bmp"
			lnBstr = SysAllocString(This.WideStr(lcTmpFile))
			OleSavePictureFile(IPic, lnBstr)
			SysFreeString(lnBstr)
			* IPicture->Release()
			lcVar = Chr(VT_DISPATCH) + Replicate(Chr(0), 7) + DWord(IPic)
			VariantClear(@lcVar)
			loPic = LoadPicture(lcTmpFile)
			Erase (lcTmpFile)
			Return loPic
#endif
		endif
	EndProc

	Procedure FromClipboard()
		Local hBmp, hPal, bmp
		If This.nativeImage != 0
			GdipDisposeImage(This.nativeImage)
		EndIf
		This.nativeImage = 0

		hBmp = 0
		hPal = 0
		If OpenClipboard(0) != 0
			hBmp = GetClipboardData(CF_BITMAP)
			hPal = GetClipboardData(CF_PALETTE)
			CloseClipboard()
		Else
			Error ERR_CLIPNOTOPEN
		EndIf
		If hBmp = 0 Or GetObjectType(hBmp) <> OBJ_BITMAP
			Error ERR_CLIPNODATA
	    EndIf

		bmp = 0
		This.stat = GdipCreateBitmapFromHBITMAP(hBmp, hPal, @bmp)
		If This.stat = 0
			This.nativeImage = bmp
		EndIf
		DeleteObject(hBmp)
    EndProc

	Procedure ToClipboard()
		Local hBmp, hReturnBmp, hndl
		hReturnBmp = 0
		This.stat = GdipCreateHBITMAPFromBitmap(This.nativeImage, @hReturnBmp, 0xFFFFFFFF)
		hBmp = CopyImage(hReturnBmp, 0, 0, 0, 0)
		DeleteObject(hReturnBmp)
		If This.stat = 0
			If OpenClipboard(0) != 0
				EmptyClipboard()
				hndl = SetClipboardData(CF_BITMAP, hBmp)
				CloseClipboard()
				If hndl = 0
					Error ERR_CLIPSETDATA
				EndIf
			Else
				Error ERR_CLIPNOTOPEN
			EndIf
		EndIf
	EndProc

	Procedure Clone
		Local cloneImage
		cloneBitmap = 0
		This.stat = GdipCloneImage(This.nativeImage, @cloneImage)
		Return CreateObject("gpImage", cloneImage)
	EndProc

	Procedure CloneArea(x, y, tnWidth, tnHeight, tcPixelFormat)
		If (Vartype(x) != 'N') or (Vartype(y) != 'N')
			Error 11
		EndIf
		If (Vartype(tnWidth) != 'N') or (Vartype(tnHeight) != 'N')
			Error 11
		EndIf
		If !Empty(tcPixelFormat) and (Vartype(tcPixelFormat) != 'C')
			Error 11
		EndIf

		Local lnFormat, gpdstBitmap
		lnFormat = 0
		If Empty(tcPixelFormat)
			This.stat = GdipGetImagePixelFormat(This.nativeImage, @lnFormat)
		Else
			lnFormat = This.StrToPixelFormat(tcPixelFormat)
		EndIf

		gpdstBitmap = 0
		This.stat = GdipCloneBitmapAreaI(x, y, tnWidth, tnHeight, ;
			lnFormat, This.nativeImage, @gpdstBitmap)
		Return CreateObject("gpImage", gpdstBitmap)
	EndProc

	Procedure Thumbnail(tnWidth, tnHeight)
		If (Vartype(tnWidth) != 'N') or (Vartype(tnHeight) != 'N')
			Error 11
		EndIf

		Local thumbImage
		thumbImage = 0
		This.stat = GdipGetImageThumbnail(This.nativeImage, tnWidth, tnHeight, @thumbImage, 0, 0)
		If This.stat = 0
			GdipDisposeImage(This.nativeImage)
			This.nativeImage = thumbImage
		EndIf
	EndProc

	Procedure SaveAsBMP(tcFileName)
		If Vartype(tcFileName) != 'C'
			Error 11
		EndIf

		Local encoderClsid, lcFile
		lcFile = DefaultExt(tcFileName, "bmp")
		Erase (lcFile)
		encoderClsid = This.StrToGuid(CLSID_BMP)
		This.stat = GdipSaveImageToFile(This.nativeImage, This.WideStr(lcFile), @encoderClsid, NULL)
	EndProc

	* tnQuality - quality of JPEG compression, 0-100, optional
	*			0 - highest compression, 100 - highest quality, default value - 75.
	* tnTransform - type of transformation without loss of information,
	*			any of EncoderValueTransform values, optional.
	Procedure SaveAsJPEG(tcFileName, tnQuality, tnTransform)
		If Vartype(tcFileName) != 'C'
			Error 11
		EndIf
		If !Empty(tnQuality) and (Vartype(tnQuality) != 'N')
			Error 11
		EndIf
		If !Empty(tnTransform) and (Vartype(tnTransform) != 'N')
			Error 11
		EndIf

		Local encoderClsid, lcFile, encoderParams, loQuality, loTransform, paramCnt
		lcFile = DefaultExt(tcFileName, "jpg")
		Erase (lcFile)
		encoderClsid = This.StrToGuid(CLSID_JPEG)

		paramCnt = 0
		encoderParams = ""
		If Vartype(tnQuality) = 'N'
			loQuality = CreateObject("EncoderParameter", This.StrToGuid(GUID_Quality), tnQuality)
			encoderParams = encoderParams + loQuality.GetString()
			paramCnt = paramCnt + 1
		EndIf
		If Vartype(tnTransform) = 'N'
			loTransform = CreateObject("EncoderParameter", This.StrToGuid(GUID_Transform), tnTransform)
			encoderParams = encoderParams + loTransform.GetString()
			paramCnt = paramCnt + 1
		EndIf

		If paramCnt > 0
		*	class EncoderParameters
		*	{
		*	public:
		*		UINT Count;						// Number of parameters in this structure
		*		EncoderParameter Parameter[1];	// Parameter values
		*	}
			encoderParams = DWord(paramCnt) + encoderParams
			This.stat = GdipSaveImageToFile(This.nativeImage, This.WideStr(lcFile), @encoderClsid, @encoderParams)
		Else
			This.stat = GdipSaveImageToFile(This.nativeImage, This.WideStr(lcFile), @encoderClsid, NULL)
		EndIf
	EndProc

	Procedure SaveAsGIF(tcFileName)
		If Vartype(tcFileName) != 'C'
			Error 11
		EndIf

		Local encoderClsid, lcFile
		lcFile = DefaultExt(tcFileName, "gif")
		Erase (lcFile)
		encoderClsid = This.StrToGuid(CLSID_GIF)
		This.stat = GdipSaveImageToFile(This.nativeImage, This.WideStr(lcFile), @encoderClsid, NULL)
	EndProc

	* tnCompress - type of compression, any of EncoderValueCompression values, optional.
	* tnColorDepth - number of colors in bits per pixel (1,4,8,16,24,32,48,64), optional.
	Procedure SaveAsTIFF(tcFileName, tnCompress, tnColorDepth)
		If Vartype(tcFileName) != 'C'
			Error 11
		EndIf
		If !Empty(tnCompress) and (Vartype(tnCompress) != 'N')
			Error 11
		EndIf
		If !Empty(tnColorDepth) and (Vartype(tnColorDepth) != 'N')
			Error 11
		EndIf

		Local encoderClsid, lcFile, encoderParams, loQuality, loTransform, paramCnt
		lcFile = DefaultExt(tcFileName, "tif")
		Erase (lcFile)
		encoderClsid = This.StrToGuid(CLSID_TIFF)

		paramCnt = 0
		encoderParams = ""
		If Vartype(tnCompress) = 'N'
			loCompress = CreateObject("EncoderParameter", This.StrToGuid(GUID_Compress), tnCompress)
			encoderParams = encoderParams + loCompress.GetString()
			paramCnt = paramCnt + 1
		EndIf
		If Vartype(tnColorDepth) = 'N'
			loColorDepth = CreateObject("EncoderParameter", This.StrToGuid(GUID_ColorDepth), tnColorDepth)
			encoderParams = encoderParams + loColorDepth.GetString()
			paramCnt = paramCnt + 1
		EndIf

		If paramCnt > 0
		*	class EncoderParameters
		*	{
		*	public:
		*		UINT Count;						// Number of parameters in this structure
		*		EncoderParameter Parameter[1];	// Parameter values
		*	}
			encoderParams = DWord(paramCnt) + encoderParams
			This.stat = GdipSaveImageToFile(This.nativeImage, This.WideStr(lcFile), @encoderClsid, @encoderParams)
		Else
			This.stat = GdipSaveImageToFile(This.nativeImage, This.WideStr(lcFile), @encoderClsid, NULL)
		EndIf
	EndProc

	* tnCompress - type of compression, any of EncoderValueCompression values, optional.
	* tnColorDepth - number of colors in bits per pixel (1,4,8,16,24,32,48,64), optional.
	Procedure SaveAsMultipageTIFF(tcFileName, tnCompress, tnColorDepth)
		If Vartype(tcFileName) != 'C'
			Error 11
		EndIf
		If !Empty(tnCompress) and (Vartype(tnCompress) != 'N')
			Error 11
		EndIf
		If !Empty(tnColorDepth) and (Vartype(tnColorDepth) != 'N')
			Error 11
		EndIf

		Local encoderClsid, lcFile, encoderParams, loQuality, loTransform, paramCnt
		lcFile = DefaultExt(tcFileName, "tif")
		Erase (lcFile)
		encoderClsid = This.StrToGuid(CLSID_TIFF)

		loCompress = CreateObject("EncoderParameter", This.StrToGuid(GUID_SaveFlag), EncoderValueMultiFrame)
		encoderParams = loCompress.GetString()
		paramCnt = 1

		If Vartype(tnCompress) = 'N'
			loCompress = CreateObject("EncoderParameter", This.StrToGuid(GUID_Compress), tnCompress)
			encoderParams = encoderParams + loCompress.GetString()
			paramCnt = paramCnt + 1
		EndIf
		If Vartype(tnColorDepth) = 'N'
			loColorDepth = CreateObject("EncoderParameter", This.StrToGuid(GUID_ColorDepth), tnColorDepth)
			encoderParams = encoderParams + loColorDepth.GetString()
			paramCnt = paramCnt + 1
		EndIf

		encoderParams = DWord(paramCnt) + encoderParams
		This.stat = GdipSaveImageToFile(This.nativeImage, This.WideStr(lcFile), @encoderClsid, @encoderParams)
	EndProc

	Function GetImage
		Return This.nativeImage
	EndFunc

	Procedure SaveAddPage(tnImage)
		If Empty(tnImage) and (Vartype(tnImage) != 'N')
			Error 11
		EndIf

		Local encoderParams, paramCnt
		loCompress = CreateObject("EncoderParameter", This.StrToGuid(GUID_SaveFlag), EncoderValueFrameDimensionPage)
		encoderParams = loCompress.GetString()
		paramCnt = 1

		encoderParams = DWord(paramCnt) + encoderParams
		This.stat = GdipSaveAddImage(This.nativeImage, tnImage, @encoderParams)
	EndProc

	Procedure SaveAsPNG(tcFileName)
		If Vartype(tcFileName) != 'C'
			Error 11
		EndIf

		Local encoderClsid, lcFile
		lcFile = DefaultExt(tcFileName, "png")
		Erase (lcFile)
		encoderClsid = This.StrToGuid(CLSID_PNG)
		This.stat = GdipSaveImageToFile(This.nativeImage, This.WideStr(lcFile), @encoderClsid, NULL)
	EndProc

	Procedure ImageFormat_Access
		Local lcFormat
		lcFormat = This.StrToGuid(GUID_FormatUndefined)
		This.stat = GdipGetImageRawFormat(This.nativeImage, @lcFormat)
		Do Case
		Case lcFormat = This.StrToGuid(GUID_FormatMemoryBMP) or lcFormat = This.StrToGuid(GUID_FormatBMP)
			Return "BMP"
		Case lcFormat = This.StrToGuid(GUID_FormatEMF)
			Return "EMF"
		Case lcFormat = This.StrToGuid(GUID_FormatWMF)
			Return "WMF"
		Case lcFormat = This.StrToGuid(GUID_FormatJPEG)
			Return "JPEG"
		Case lcFormat = This.StrToGuid(GUID_FormatPNG)
			Return "PNG"
		Case lcFormat = This.StrToGuid(GUID_FormatGIF)
			Return "GIF"
		Case lcFormat = This.StrToGuid(GUID_FormatTIFF)
			Return "TIFF"
		Case lcFormat = This.StrToGuid(GUID_FormatEXIF)
			Return "EXIF"
		Case lcFormat = This.StrToGuid(GUID_FormatIcon)
			Return "ICON"
		Otherwise
			Return "UNDEFINED"
		EndCase
	EndProc

	Procedure PixelFormat_Access
		Local lnFormat
		lnFormat = 0
		This.stat = GdipGetImagePixelFormat(This.nativeImage, @lnFormat)
		Do Case
		Case lnFormat = PixelFormat1bppIndexed
			Return "1bppIndexed"
		Case lnFormat = PixelFormat4bppIndexed
			Return "4bppIndexed"
		Case lnFormat = PixelFormat8bppIndexed
			Return "8bppIndexed"
		Case lnFormat = PixelFormat16bppGrayScale
			Return "16bppGrayScale"
		Case lnFormat = PixelFormat16bppRGB555
			Return "16bppRGB555"
		Case lnFormat = PixelFormat16bppRGB565
			Return "16bppRGB565"
		Case lnFormat = PixelFormat16bppARGB1555
			Return "16bppARGB1555"
		Case lnFormat = PixelFormat24bppRGB
			Return "24bppRGB"
		Case lnFormat = PixelFormat32bppRGB
			Return "32bppRGB"
		Case lnFormat = PixelFormat32bppARGB
			Return "32bppARGB"
		Case lnFormat = PixelFormat32bppPARGB
			Return "32bppPARGB"
		Case lnFormat = PixelFormat48bppRGB
			Return "48bppRGB"
		Case lnFormat = PixelFormat64bppARGB
			Return "64bppARGB"
		Case lnFormat = PixelFormat64bppPARGB
			Return "64bppPARGB"
		Otherwise
			Return "Undefined"
		EndCase
	EndProc

	Procedure PixelFormat_Assign(tcFormat)
		If Vartype(tcFormat) != 'C'
			Error 11
		EndIf

		Local lnFormat, lnWidth, lnHeight, gpdstBitmap
		lnFormat = this.StrToPixelFormat(tcFormat)

		lnWidth = 0
		This.stat = GdipGetImageWidth(This.nativeImage, @lnWidth)
		lnHeight = 0
		This.stat = GdipGetImageHeight(This.nativeImage, @lnHeight)
		gpdstBitmap = 0
		This.stat = GdipCloneBitmapAreaI(0, 0, lnWidth, lnHeight, ;
			lnFormat, This.nativeImage, @gpdstBitmap)
		If This.stat = 0
			GdipDisposeImage(This.nativeImage)
			This.nativeImage = gpdstBitmap
		EndIf
	EndProc

	Procedure ImageWidth_Access
		Local lnWidth
		lnWidth = 0
		This.stat = GdipGetImageWidth(This.nativeImage, @lnWidth)
		Return lnWidth
	EndProc

	Procedure ImageHeight_Access
		Local lnHeight
		lnHeight = 0
		This.stat = GdipGetImageHeight(This.nativeImage, @lnHeight)
		Return lnHeight
	EndProc

	Procedure HorizontalResolution_Access
		Local lnResolution
		lnResolution = 0
		This.stat = GdipGetImageHorizontalResolution(This.nativeImage, @lnResolution)
		Return lnResolution
	EndProc

	Procedure VerticalResolution_Access
		Local lnResolution
		lnResolution = 0
		This.stat = GdipGetImageVerticalResolution(This.nativeImage, @lnResolution)
		Return lnResolution
	EndProc

	Procedure HorizontalResolution_Assign(tnResolution)
		If Vartype(tnResolution) != 'N'
			Error 11
		EndIf

		Local lnVertRes
		lnVertRes = 0
		This.stat = GdipGetImageVerticalResolution(This.nativeImage, @lnVertRes)
		This.stat = GdipBitmapSetResolution(This.nativeImage, tnResolution, lnVertRes)
	EndProc

	Procedure VerticalResolution_Assign(tnResolution)
		If Vartype(tnResolution) != 'N'
			Error 11
		EndIf

		Local lnHorRes
		lnHorRes = 0
		This.stat = GdipGetImageHorizontalResolution(This.nativeImage, @lnHorRes)
		This.stat = GdipBitmapSetResolution(This.nativeImage, lnHorRes, tnResolution)
	EndProc

	Procedure GetPixelColor(x, y)
		If (Vartype(x) != 'N') or (Vartype(y) != 'N')
			Error 11
		EndIf

		Local argb, red, green, blue
		argb = 0
		This.stat = GdipBitmapGetPixel(This.nativeImage, x, y, @argb)
		red = Bitrshift(Bitand(argb, 0x00FF0000), 16)
		green = Bitrshift(Bitand(argb, 0x0000FF00), 8)
		blue = Bitand(argb, 0x000000FF)
		This.PixelRed   = Red
		This.PixelGreen = Green
		This.PixelBlue  = Blue
		Return red + Bitlshift(green, 8) + Bitlshift(blue, 16)
	EndProc

	Procedure GetPixelAlpha(x, y)
		If (Vartype(x) != 'N') or (Vartype(y) != 'N')
			Error 11
		EndIf

		Local argb
		argb = 0
		This.stat = GdipBitmapGetPixel(This.nativeImage, x, y, @argb)
		Return Bitrshift(argb, 24)
	EndProc

	Procedure SetPixel(x, y, tnColor, tnAlpha)
		If (Vartype(x) != 'N') or (Vartype(y) != 'N') or (Vartype(tnColor) != 'N')
			Error 11
		EndIf
		If !Empty(tnAlpha) and (Vartype(tnAlpha) != 'N')
			Error 11
		EndIf

		Local argb
		argb = MakeARGB(tnColor, tnAlpha)
		This.stat = GdipBitmapSetPixel(This.nativeImage, x, y, argb)
	EndProc

	Procedure Crop(x, y, tnWidth, tnHeight)
		If (Vartype(x) != 'N') or (Vartype(y) != 'N')
			Error 11
		EndIf
		If (Vartype(tnWidth) != 'N') or (Vartype(tnHeight) != 'N')
			Error 11
		EndIf

		Local lnFormat, gpdstBitmap
		lnFormat = 0
		This.stat = GdipGetImagePixelFormat(This.nativeImage, @lnFormat)
		gpdstBitmap = 0
		This.stat = GdipCloneBitmapAreaI(x, y, tnWidth, tnHeight, ;
			lnFormat, This.nativeImage, @gpdstBitmap)
		If This.stat = 0
			GdipDisposeImage(This.nativeImage)
			This.nativeImage = gpdstBitmap
		EndIf
	EndProc

	Procedure RotateFlip(rotateFlipType)
		If Vartype(rotateFlipType) != 'N'
			Error 11
		EndIf

		This.stat = GdipImageRotateFlip(This.nativeImage, rotateFlipType)
	EndProc

	Procedure Resize(tnWidth, tnHeight, tnInterpolationMode)
		If (Vartype(tnWidth) != 'N') or (Vartype(tnHeight) != 'N')
			Error 11
		EndIf
		If !Empty(tnInterpolationMode) and (Vartype(tnInterpolationMode) != 'N')
			Error 11
		EndIf
		If Vartype(tnInterpolationMode) != 'N'
			tnInterpolationMode = InterpolationModeDefault
		EndIf

		Local lnFormat, graphics, resizedImage
		lnFormat = 0
		graphics = 0
		resizedImage = 0

		This.stat = GdipGetImagePixelFormat(This.nativeImage, @lnFormat)
		This.stat = GdipCreateBitmapFromScan0(tnWidth, tnHeight, 0, lnFormat, 0, @resizedImage)
		If This.stat != 0
			Return
		EndIf
		This.stat = GdipGetImageGraphicsContext(resizedImage, @graphics)
		If This.stat != 0
			Return
		EndIf
		This.stat = GdipSetInterpolationMode(graphics, tnInterpolationMode)
		This.stat = GdipDrawImageRectI(graphics, This.nativeImage, 0, 0, tnWidth, tnHeight)
		If This.stat = 0
			GdipDisposeImage(This.nativeImage)
			This.nativeImage = resizedImage
		EndIf
	EndProc

	Function GetPageCount()
		Local dimensionID, count
		dimensionID = This.StrToGuid(GUID_Page)
		count = 0

		GdipImageGetFrameCount(This.nativeImage, @dimensionID, @count)
		Return count
	EndFunc

	Procedure SelectPage(tnPage)
		If (Vartype(tnPage) != 'N')
			Error 11
		EndIf

		Local dimensionID
		dimensionID = This.StrToGuid(GUID_Page)
		GdipImageSelectActiveFrame(This.nativeImage, @dimensionID, tnPage)
	EndProc

	Function GetFrameCount()
		Local dimensionID, count
		dimensionID = This.StrToGuid(GUID_Time)
		count = 0

		GdipImageGetFrameCount(This.nativeImage, @dimensionID, @count)
		Return count
	EndFunc

	Procedure SelectFrame(tnFrame)
		If (Vartype(tnFrame) != 'N')
			Error 11
		EndIf

		Local dimensionID
		dimensionID = This.StrToGuid(GUID_Time)
		GdipImageSelectActiveFrame(This.nativeImage, @dimensionID, tnFrame)
	EndProc

	Procedure Capture(thWnd)
		If VarType(thWnd) != 'N'
			Error 11
		EndIf

		If This.nativeImage != 0
			GdipDisposeImage(This.nativeImage)
		EndIf
		This.nativeImage = 0

		Local bmp
		Local lhDC, lhMemDC, lhOldBmp, lhMemBmp
		Local lnWidth, lnHeight

		If Empty(thWnd)
			thWnd = GetDesktopWindow()
		EndIf
		lhDC = GetWindowDC(thWnd)
		= This.GetWinRect(thWnd, @lnWidth, @lnHeight)

	    lhMemDC = CreateCompatibleDC(lhDC)
	    lhMemBmp = CreateCompatibleBitmap(lhDC, lnWidth, lnHeight)

	    lhOldBmp = SelectObject(lhMemDC, lhMemBmp)
	    = BitBlt(lhMemDC, 0, 0, lnWidth, lnHeight, lhDC, 0, 0, SRCCOPY)
	    = SelectObject(lhMemDC, lhOldBmp)

		= DeleteDC(lhMemDC)
	    = ReleaseDC(thWnd, lhDC)

		bmp = 0
		This.stat = GdipCreateBitmapFromHBITMAP(lhMemBmp, 0, @bmp)
		If This.stat = 0
			This.nativeImage = bmp
		EndIf
		DeleteObject(lhMemBmp)
	EndProc

*!*		Procedure Print(tcPrinter)
*!*			If !Empty(tcPrinter) and (Vartype(tcPrinter) != 'C')
*!*				Error 11
*!*			EndIf
*!*		EndProc

*!*		Procedure PrintWithDlg
*!*		EndProc

*!*		Procedure Gamma(tnGamma)
*!*		EndProc


*!*		Procedure MapColor(tnOldColor, tnNewColor, tnOldAlpha, tnNewAlpha)
*!*			If (Vartype(tnOldColor) != 'N') or (Vartype(tnNewColor) != 'N')
*!*				Error 11
*!*			EndIf
*!*			If !Empty(tnOldAlpha) and (Vartype(tnOldAlpha) != 'N')
*!*				Error 11
*!*			EndIf
*!*			If !Empty(tnNewAlpha) and (Vartype(tnNewAlpha) != 'N')
*!*				Error 11
*!*			EndIf

*!*			Local argbOld, argbNew
*!*			argbOld = MakeARGB(tnOldColor, tnOldAlpha)
*!*			argbNew = MakeARGB(tnNewColor, tnNewAlpha)

*!*			Local lnFormat, graphics, newImage
*!*			lnFormat = 0
*!*			graphics = 0
*!*			newImage = 0

*!*			This.stat = GdipGetImagePixelFormat(This.nativeImage, @lnFormat)
*!*			This.stat = GdipCreateBitmapFromScan0(tnWidth, tnHeight, 0, lnFormat, 0, @newImage)
*!*			If This.stat != 0
*!*				Return
*!*			EndIf
*!*			This.stat = GdipGetImageGraphicsContext(newImage, @graphics)
*!*			If This.stat != 0
*!*				Return
*!*			EndIf
*!*	*!*			This.stat = GdipSetImageAttributesRemapTable(GpImageAttributes *imageattr,
*!*	*!*	                                 ColorAdjustType type,
*!*	*!*	                                 BOOL enableFlag,
*!*	*!*	                                 UINT mapSize,
*!*	*!*	                                 GDIPCONST ColorMap *map)
*!*			This.stat = GdipDrawImageRectI(graphics, This.nativeImage, 0, 0, tnWidth, tnHeight)
*!*			If This.stat = 0
*!*				GdipDisposeImage(This.nativeImage)
*!*				This.nativeImage = newImage
*!*			EndIf
*!*		EndProc

*!*		Procedure TransformColors
*!*		EndProc

***********************************************************************
* Protected functions
***********************************************************************

*!*		Protected Procedure PrintHDC(thDC)
*!*		EndProc

	Protected Procedure GetWinRect(hWnd, lnWidth, lnHeight)
	* Returns width and height of window, passed by handle
	    Local lpRect, lnLeft, lnTop, lnRight, lnBottom
	    lpRect = Replicate(Chr(0), 16)
	    = GetWindowRect(hWnd, @lpRect)

	    lnLeft   = This.LongToNum(SubStr(lpRect,  1, 4))   
	    lnTop    = This.LongToNum(SubStr(lpRect,  5, 4))   
	    lnRight  = This.LongToNum(SubStr(lpRect,  9, 4))   
	    lnBottom = This.LongToNum(SubStr(lpRect, 13, 4))   

	    lnWidth  = lnRight - lnLeft 
	    lnHeight = lnBottom - lnTop 
	EndProc

	Protected Function LongToNum(tcLong)
	* Converts a signed long value to a VFP numeric
		Local nNum
		nNum = 0
		RtlCopyLong(@nNum, tcLong, 4)
		Return nNum
	EndFunc

	Protected Function StrToPixelFormat(tcFormat)
		tcFormat = Upper(tcFormat)
		Do Case
		Case tcFormat = "1BPPINDEXED"
			return PixelFormat1bppIndexed
		Case tcFormat = "4BPPINDEXED"
			return PixelFormat4bppIndexed
		Case tcFormat = "8BPPINDEXED"
			return PixelFormat8bppIndexed
		Case tcFormat = "16BPPGRAYSCALE"
			return PixelFormat16bppGrayScale
		Case tcFormat = "16BPPRGB555"
			return PixelFormat16bppRGB555
		Case tcFormat = "16BPPRGB565"
			return PixelFormat16bppRGB565
		Case tcFormat = "16BPPARGB1555"
			return PixelFormat16bppARGB1555
		Case tcFormat = "24BPPRGB"
			return PixelFormat24bppRGB
		Case tcFormat = "32BPPRGB"
			return PixelFormat32bppRGB
		Case tcFormat = "32BPPARGB"
			return PixelFormat32bppARGB
		Case tcFormat = "32BPPPARGB"
			return PixelFormat32bppPARGB
		Case tcFormat = "48BPPRGB"
			return PixelFormat48bppRGB
		Case tcFormat = "64BPPARGB"
			return PixelFormat64bppARGB
		Case tcFormat = "64BPPPARGB"
			return PixelFormat64bppPARGB
		Otherwise
			Error 11
		EndCase
	EndFunc

	Protected Function StrToGuid(s)
		Local guid
		guid = Space(16)
		s = Chrtran(s, "{}", "")
		UuidFromString(s, @guid)
		Return guid
	EndFunc

	Protected Function WideStr(tcStr)
#if Version(5) >= 700
		Return Strconv(tcStr + Chr(0), 5)
#else
		Local lnLen, lcWideStr
		lnLen = 2 * (Len(tcStr) + 1)
		lcWideStr = Replicate(Chr(0), lnLen)
		MultiByteToWideChar(0, 0, @tcStr, Len(tcStr), @lcWideStr, lnLen)
		Return lcWideStr
#endif
	EndFunc

	Protected Procedure stat_Assign(tnStatus)
		If tnStatus != 0
			Local res
			res = MessageBox("GDI+ error in " + Program(Program(-1) - 1) + CRLF;
				+ "Error code : " + Transform(tnStatus) + CRLF ;
				+ "Description: " + ErrorInfo(tnStatus) + CRLF + CRLF;
				+ "Press 'Retry' to debug the application.", 16 + 2, "Error")
			If res = 3
				Cancel
			EndIf
			If res = 4
				Suspend
			EndIf
		EndIf
		This.stat = tnStatus
	EndProc

EndDefine


***********************************************************************
*   Class:	Graphics
***********************************************************************

Define Class Graphics as Custom
	Protected stat
	Protected nativeGraphics
	PROTECTED nativeImage
	
	nativeImage = 0
	nativeGraphics = 0
	brush    = 0
	pen      = 0
	rectf    = 0
	nalign   = 0
	StringMeasure = .T.
	StringW  = 0 && Gets Width  from MeasureString
	StringH  = 0 && Gets Height from MeasureString
	StringChars = 0
	StringLines = 0
	PageScale   = 0
	ImgAttribs  = 0
	InterpolationMode = 0
	SmoothingMode = 0

#DEFINE SmoothingModeInvalid  -1 
#DEFINE SmoothingModeDefault  0 
#DEFINE SmoothingModeHighSpeed  1 
#DEFINE SmoothingModeHighQuality 2 
#DEFINE SmoothingModeNone   3 
#DEFINE SmoothingModeAntiAlias  4 

#DEFINE InterpolationModeInvalid    -1 
#DEFINE InterpolationModeDefault    0 
#DEFINE InterpolationModeLowQuality    1 
#DEFINE InterpolationModeHighQuality   2 
#DEFINE InterpolationModeBilinear    3 
#DEFINE InterpolationModeBicubic    4 
#DEFINE InterpolationModeNearestNeighbor  5 
#DEFINE InterpolationModeHighQualityBilinear 6 
#DEFINE InterpolationModeHighQualityBicubic  7 

PROCEDURE SmoothingMode_Access
	declare integer GdipGetSmoothingMode in gdiplus.dll ;
		integer nGraphics, integer @
	LOCAL nSmoothingMode
	nSmoothingMode = 0
	This.Stat = GdipGetSmoothingMode( This.getgraphics(), @nSmoothingMode)
	RETURN nSmoothingMode
ENDPROC

PROCEDURE SmoothingMode_Assign(tnMode)
	declare integer GdipSetSmoothingMode in gdiplus.dll ;
		integer nGraphics, integer
	This.Stat = GdipSetSmoothingMode( This.GetGraphics(),m.tnMode)
ENDPROC 

PROCEDURE InterpolationMode_Access
	declare integer GdipGetInterpolationMode in gdiplus.dll ;
		integer nGraphics, integer @
	local nMode
	nMode = 0
	This.Stat = GdipGetInterpolationMode ( This.GetGraphics(), @nMode)
	RETURN nMode
ENDPROC 

PROCEDURE InterpolationMode_Assign(tnInterpMode)
	declare integer GdipSetInterpolationMode in gdiplus.dll ;
		integer nGraphics, integer
	This.Stat = GdipSetInterpolationMode ( This.GetGraphics(),m.tnInterpMode)
ENDPROC
	
	PROTECTED Procedure Init(tnNImage,tcMODE)
		IF PCOUNT() = 0
			RETURN
		ENDIF
		
		IF !(VARTYPE(m.tnNImage) == "N")
			ERROR 11
		ENDIF

		IF PCOUNT() = 1
			tcMode = "IMG"
		ENDIF 
		
		This.NativeImage    = tnNImage
		DO CASE 
			CASE UPPER(tcMode) = "IMG"
				This.CreateFromImage(m.tnNImage)
			CASE UPPER(tcMode) = "HWND"
				This.CreateFromHWND(tnNImage)
			CASE UPPER(tcMode) = "HDC"

		ENDCASE 
	ENDPROC


	FUNCTION CreateFromImage(tnImage)
		LOCAL graphics
		graphics = 0
		This.Stat = GdipGetImageGraphicsContext(m.tnImage, @graphics)
		This.NativeImage = tnImage
		This.NativeGraphics = m.graphics
		RETURN m.graphics
	ENDFUNC 

	PROCEDURE CreateFromHWND(tnHWND)
		LOCAL graphics
		graphics = 0
		This.Stat = GdipCreateFromHWND(m.tnHWND, @graphics)
		This.NativeGraphics = m.graphics 
		RETURN m.graphics
	ENDPROC 

	PROTECTED Procedure Destroy
		IF This.Pen <> 0
			=GdipDeletePen(This.Pen)
		ENDIF 

		IF This.Brush <> 0
			=GdipDeleteBrush(This.Brush)
		ENDIF 
	
		IF This.nativeGraphics != 0
			=GdipDeleteGraphics(This.nativeGraphics)
		ENDIF 
	ENDPROC 

	Protected Procedure stat_Assign(tnStatus)
		If tnStatus != 0
			Local res
			res = MessageBox("GDI+ error in " + Program(Program(-1) - 1) + CRLF;
				+ "Error code : " + Transform(tnStatus) + CRLF ;
				+ "Description: " + ErrorInfo(tnStatus) + CRLF + CRLF;
				+ "Press 'Retry' to debug the application.", 16 + 2, "Error")
			If res = 3
				Cancel
			EndIf
			If res = 4
				Suspend
			EndIf
		ENDIF
		This.stat = tnStatus
	EndProc


*!*	PEN FUNCTIONS

	PROCEDURE SetPen(tnColor,tnWidth,tnUnit,tnDashStyle)
		IF VARTYPE(tnColor) <> 'N'
			ERROR 11	&& function argument
		ENDIF
		IF VARTYPE(tnWidth) == 'L'
			tnWidth = 1.0
		ENDIF 
		IF VARTYPE(tnUnit) == 'L'
			tnUnit = 0
		ENDIF 

		IF This.Pen <> 0
			This.DeletePen(This.Pen)
		ENDIF 
		gdipen = 0
		lnARGB = makeargb(tncolor)
		This.stat = GdipCreatePen1(lnARGB, tnWidth, tnUnit, @gdipen)
		This.Pen  = GdiPen
	ENDPROC
	
	PROCEDURE SetPenDash(tnDashStyle)
		IF PCOUNT() = 0 && Reset DashStyle to Solid
			tnDashStyle = 0
		ENDIF
		IF VARTYPE(tnDashStyle) <> 'N'
			ERROR 11	&& function argument
		ENDIF
		This.Stat = GdipSetPenDashStyle(This.Pen, m.tnDashStyle)
	ENDPROC
	
	PROCEDURE DeletePen(tnPen)
		This.Stat = GdipDeletePen(m.tnPen)
		This.Pen  = 0
	ENDPROC 
	


*!*	BRUSH FUNCTIONS

	PROCEDURE SetBrush(tnColor, tnAlpha)
		IF PCOUNT() = 1
			STORE 255 TO tnAlpha && Opaque
		ENDIF 
		IF VARTYPE(tnColor) != 'N' OR VARTYPE(tnColor) != 'N'
			ERROR 11	&& function argument
		ENDIF

		IF This.Brush <> 0
			This.DeleteBrush(This.Brush)
		ENDIF 
		gdibrush = 0
		This.stat  = GdipCreateSolidFill(makeARGB(tnColor,tnAlpha), @gdiBrush)
		This.Brush = GdiBrush
	ENDPROC 		
	
	PROCEDURE SetHatchBrush(tnHatchStyle, tnBackCol, tnBackAlpha, tnForeCol, tnForeAlpha)
		IF VARTYPE(tnHatchStyle) + VARTYPE(tnBackCol) + VARTYPE(tnBackAlpha) <> "NNN"
			ERROR 11	&& function argument
		ENDIF

		IF VARTYPE(tnForeCol) = "L"
			tnForeCol = 0 && Black
		ENDIF
		
		IF VARTYPE(tnForeAlpha) = "L"
			tnBackCol = 255 && Opaque
		ENDIF

		IF This.Brush <> 0
			This.DeleteBrush(This.Brush)
		ENDIF 
		gdibrush = 0
		This.stat  = GdipCreateHatchBrush(tnHatchStyle, ;
			makeARGB(tnForeCol,tnForeAlpha), makeARGB(tnBackCol, tnBackAlpha), @gdiBrush)
		This.Brush = GdiBrush
	ENDPROC 


	PROCEDURE SetTextureBrush(tcFileName, tnWrapMode)
		IF NOT VARTYPE(m.tcFileName) $ "CN"
			ERROR 11 && function argument
		ENDIF 
		
		IF VARTYPE(m.tnWrapMode) = "L"
			tnWrapMode = 0 && WrapModeTile - Default
		ENDIF
		
		LOCAL lnPasteImage
		IF VARTYPE(m.tcFileName) = "C"  && Image file to load
			lnPasteImage = 0
			This.stat = GdipLoadImageFromFile(This.WideStr(tcFileName), @lnPasteImage)
		ELSE && Use other image handle
			lnPasteImage = tcFileName
		ENDIF 
		IF This.Brush <> 0
			This.DeleteBrush(This.Brush)
		ENDIF 
		gdibrush = 0

		This.stat = GdipCreateTexture(lnPasteImage, tnWrapMode, @gdiBrush)
		IF lnPasteImage <> This.NativeImage
			This.stat = GdipDisposeImage(lnPasteImage)
		ENDIF
		This.Brush = GdiBrush
	ENDPROC 

	PROCEDURE DeleteBrush(tnBrush)
		This.Stat = GdipDeleteBrush(m.tnBrush)
		This.Brush = 0
	ENDPROC 


*!*	GRAPHICS FUNCTIONS	

	PROCEDURE TranslateTransform(tndX, tndY)
		IF VARTYPE(m.tndX) + VARTYPE(m.tndY) <> 'NN'
			ERROR 11 && function argument
		ENDIF
		This.stat = GdipTranslateWorldTransform(This.GetGraphics(), tndX, tndY, 0)
	ENDPROC
	
	PROCEDURE RotateTransform(tnAngle)
		IF VARTYPE(m.tnAngle) <> 'N'
			ERROR 11 && function argument
		ENDIF
		This.stat = GdipRotateWorldTransform(This.getgraphics(), tnAngle, 0)
	ENDPROC

	PROCEDURE ResetTransform
		This.Stat = GdipResetWorldTransform(This.getGraphics())
	ENDPROC 


*!*	STRING FUNCTIONS

	PROCEDURE DrawString(tcText, tcFontName, tnSize, tcFontStyle, tlMeasure)
		IF !(VARTYPE(tcText) + VARTYPE(tcFontName) + VARTYPE(tnSize) + ;
				VARTYPE(tcFontStyle) + VARTYPE(tlMeasure) == 'CCNCL')
			ERROR 11	&& function argument
		ENDIF

		lnFontStyle = GDIPLUS_FontStyle_Regular && 0
		tcFontStyle = UPPER(tcFontStyle)
		IF "B" $ tcFontStyle
			lnFontStyle = lnFontStyle + GDIPLUS_FontStyle_Bold && 1
		ENDIF
		IF "I" $ tcFontStyle
			lnFontStyle = lnFontStyle + GDIPLUS_FontStyle_Italic && 2
		ENDIF
		IF "U" $ tcFontStyle
			lnFontStyle = lnFontStyle + GDIPLUS_FontStyle_Underline && 4
		ENDIF
		IF "S" $ tcFontStyle
			lnFontStyle = lnFontStyle + GDIPLUS_FontStyle_Strikeout && 8
		ENDIF

		LOCAL lnFontFamily, lnFont, lcText, lcFontName, lcRectangleF
		STORE 0 TO lnFontFamily, lnFont && handles for FontFamily & FontName

		lcText       = This.Widestr(tcText) 
		lcFontName   = This.Widestr(tcFontName)
		lcRectangleF = This.Rectf

		This.stat = GdipCreateFontFamilyFromName(lcFontName, 0, @lnFontFamily)
		This.stat = GdipCreateFont(lnFontFamily, tnSize, lnFontStyle, 3, @lnFont) 


		This.stat = GdipDrawString(This.getgraphics(), lcText, LEN(tcText), lnFont, ;
			@lcRectangleF, This.nAlign, This.Brush)

		IF tlMeasure = .T. OR This.StringMeasure = .T.
			This.GetMeasures(lcText, lnFont)
		ENDIF 

		*** Clearing Font Handles
		This.stat = GdipDeleteFont(lnFont)
		This.stat = GdipDeleteFontFamily(lnFontFamily)
	ENDPROC

	PROTECTED PROCEDURE GetMeasures(tcText, tnFontHandle)
		LOCAL lcBoundingBox, lnCodePointsFitted, lnLines, lcRectangleF

		lcRectangleF = REPLICATE(CHR(0),16)
		lcBoundingBox = REPLICATE(CHR(0),16)
		lnChars = 0
		lnLines = 0

		This.Stat = GdipMeasureString(This.getgraphics(), m.tcText, -1, ;
			m.tnFontHandle, m.lcRectangleF, This.nAlign, @lcBoundingBox, @lnChars, @lnLines)

		This.GetRectfBounds(RIGHT(m.lcBoundingBox,8))

		This.StringChars = lnChars
		This.StringLines = lnLines
	ENDPROC

	PROTECTED FUNCTION GetRectfBounds(tcBoxf)
		This.StringW = float2int(buf2dword(SUBSTR(m.tcBoxF,1,4)))
		This.StringH = float2int(buf2dword(SUBSTR(m.tcBoxF,5,4)))
	ENDFUNC 

	PROCEDURE MeasureString(tcText, tcFontName, tnSize, tcFontStyle)
		IF !(VARTYPE(tcText) + VARTYPE(tcFontName) + VARTYPE(tnSize) + VARTYPE(tcFontStyle) == 'CCNC')
			ERROR 11	&& function argument
		ENDIF

		lnFontStyle = GDIPLUS_FontStyle_Regular && 0
		tcFontStyle = UPPER(tcFontStyle)
		IF "B" $ tcFontStyle
			lnFontStyle = lnFontStyle + GDIPLUS_FontStyle_Bold && 1
		ENDIF
		IF "I" $ tcFontStyle
			lnFontStyle = lnFontStyle + GDIPLUS_FontStyle_Italic && 2
		ENDIF
		IF "U" $ tcFontStyle
			lnFontStyle = lnFontStyle + GDIPLUS_FontStyle_Underline && 4
		ENDIF
		IF "S" $ tcFontStyle
			lnFontStyle = lnFontStyle + GDIPLUS_FontStyle_Strikeout && 8
		ENDIF

		LOCAL lnFontFamilyHandle, lnRectf, lnFontHandle
		STORE 0 TO lnFontFamily, lnFont && handles for FontFamily & FontName

		lcText     = This.Widestr(tcText)
		lcFontName = This.Widestr(tcFontName)
		lnRectf    = This.Rectf

		This.stat = GdipCreateFontFamilyFromName(lcFontName, 0, @lnFontFamilyHandle)
		This.stat = GdipCreateFont(lnFontFamilyHandle, tnSize, lnFontStyle, 3, @lnFontHandle) 

		LOCAL lcBoundingBox, lnCodePointsFitted, lnLines, lcRectangleF

		lcRectangleF  = REPLICATE(CHR(0),16)
		lcBoundingBox = REPLICATE(CHR(0),16)
		lnChars = 0
		lnLines = 0

		This.Stat = GdipMeasureString(This.getgraphics(), lcText, -1, ;
			lnFontHandle, m.lcRectangleF, This.nAlign, @lcBoundingBox, @lnChars, ;
			@lnLines)

		This.GetRectfBounds(RIGHT(m.lcBoundingBox,8))

		*** Clearing Font Handles
		This.stat = GdipDeleteFont(lnFontHandle)
		This.stat = GdipDeleteFontFamily(lnFontFamilyHandle)
	ENDPROC

	PROCEDURE SetRect(x, y, tnWidth, tnHeight)
		IF PCOUNT() = 2
			STORE 0 TO tnWidth, tnHeight
		ENDIF 
		
		IF !(VARTYPE(m.x) + VARTYPE(m.y) + VARTYPE(tnWidth) + VARTYPE(tnHeight) == 'NNNN')
			ERROR 11	&& function argument
		ENDIF 
		This.Rectf = rectf(m.x, m.y, tnWidth, tnHeight)
	ENDPROC 

	PROCEDURE SetAlignment(thAlignment,tvAlignment,tFlags) && Horizontal - Vertical - Flags
		IF PCOUNT() = 1
			STORE 0 TO tvAlignment, tFlags
		ENDIF 
		IF PCOUNT() = 2
			STORE 0 TO tFlags
		ENDIF 
		IF !(VARTYPE(m.thAlignment) + VARTYPE(m.tvAlignment) + VARTYPE(m.tFlags) == 'NNN')
			ERROR 11	&& function argument
		ENDIF 
    	lnFormatHandle = 0
		This.Stat = GdipCreateStringFormat(tFlags, 0, @lnFormatHandle )
		This.Stat = GdipSetStringFormatAlign(lnFormatHandle, m.thAlignment)
		This.Stat = GdipSetStringFormatLineAlign(lnFormatHandle, m.tvAlignment)
		This.nAlign = lnFormatHandle
	ENDPROC 


*!*	DRAWING SHAPES FUNCTIONS

	PROCEDURE DrawLine(tnX1, tnY1, tnX2, tnY2)
		IF VARTYPE(m.tnx1) + VARTYPE(m.tny1) + VARTYPE(m.tnx2) + VARTYPE(m.tny2) <> 'NNNN'
			ERROR 11	&& function argument
		ENDIF
		This.stat = GdipDrawLine(This.getgraphics(), This.Pen, tnx1, tny1, tnx2, tny2)
	ENDPROC 

	
	PROCEDURE DrawRect(tnx, tny, tnWidth, tnHeight)
		IF VARTYPE(m.tnx) + VARTYPE(m.tny) + VARTYPE(m.tnWidth) + VARTYPE(m.tnHeight) <> 'NNNN'
			ERROR 11	&& function argument
		ENDIF
		= GdipDrawRectangle(This.getgraphics(), This.Pen, m.tnx, m.tny, m.tnWidth, m.tnHeight)
	ENDPROC 

	PROCEDURE FillRect(tnx, tny, tnWidth, tnHeight)
		IF VARTYPE(m.tnx) + VARTYPE(m.tny) + VARTYPE(tnWidth) + VARTYPE(tnHeight) <> 'NNNN'
			ERROR 11	&& function argument
		ENDIF 
		This.stat = GdipFillRectangle(This.GetGraphics(), This.Brush, m.tnx, m.tny, tnWidth, tnHeight)
	ENDPROC 


	PROCEDURE DrawEllipse(tnX, tnY, tnW, tnH)
		IF VARTYPE(m.tnX) + VARTYPE(m.tnY) + VARTYPE(m.tnW) + VARTYPE(m.tnH) <> 'NNNN'
			ERROR 11 && function argument
		ENDIF
		This.Stat = GdipDrawEllipse(This.getGraphics(), This.Pen, m.tnX, m.tnY, m.tnW, m.tnH)
	ENDPROC 
	
	PROCEDURE FillEllipse(tnX, tnY, tnW, tnH)
		IF VARTYPE(m.tnX) + VARTYPE(m.tnY) + VARTYPE(m.tnW) + VARTYPE(m.tnH) <> 'NNNN'
			ERROR 11 && function argument
		ENDIF
		This.stat = GdipFillEllipse(This.getgraphics(), This.Brush, m.tnX, m.tnY, m.tnW, m.tnH)
	ENDPROC 	

	
	PROCEDURE DrawPie(tnx, tny, tnw, tnh, tnStartAngle, tnSweepAngle)
		IF VARTYPE(m.tnX) + VARTYPE(m.tnY) + VARTYPE(m.tnW) + VARTYPE(m.tnH) + ;
					VARTYPE(m.tnStartAngle) + VARTYPE(m.tnSweepAngle) <> 'NNNNNN'
			ERROR 11 && function argument
		ENDIF
		This.Stat = GdipDrawPie(This.GetGraphics(), This.Pen, m.tnX, m.tnY, ;
			m.tnW, m.tnH, m.tnStartAngle, m.tnSweepAngle)
	ENDPROC 

	PROCEDURE FillPie(tnx, tny, tnw, tnh, tnStartAngle, tnSweepAngle)
		IF VARTYPE(m.tnX) + VARTYPE(m.tnY) + VARTYPE(m.tnW) + VARTYPE(m.tnH) + ;
					VARTYPE(m.tnStartAngle) + VARTYPE(m.tnSweepAngle) <> 'NNNNNN'
			ERROR 11 && function argument
		ENDIF
		This.Stat = GdipFillPie(This.GetGraphics(), This.Brush, m.tnX, m.tnY, ;
			m.tnW, m.tnH, m.tnStartAngle, m.tnSweepAngle)
	ENDPROC 


	PROCEDURE DrawArc(tnx, tny, tnw, tnh, tnStartAngle, tnSweepAngle)
		IF VARTYPE(m.tnX) + VARTYPE(m.tnY) + VARTYPE(m.tnW) + VARTYPE(m.tnH) + ;
					VARTYPE(m.tnStartAngle) + VARTYPE(m.tnSweepAngle) <> 'NNNNNN'
			ERROR 11 && function argument
		ENDIF
		This.Stat = GdipDrawArc(This.GetGraphics(), This.Pen, m.tnX, m.tnY, ;
			m.tnW, m.tnH, m.tnStartAngle, m.tnSweepAngle)
	ENDPROC 
		

	PROCEDURE DrawPolygon(taPoints)
		LOCAL lcPoints
		lcPoints = MakePointsFSequence(@taPoints)
		This.Stat = GdipDrawPolygon(This.GetGraphics(), This.Pen, ;
			m.lcPoints, ALEN(taPoints,1))
	ENDPROC 

	PROCEDURE FillPolygon(taPoints)
		LOCAL lcPoints
		lcPoints = MakePointsFSequence(@taPoints)
		This.Stat = GdipFillPolygon( This.GetGraphics(), This.Brush, ;
			m.lcPoints, ALEN(taPoints,1), 0 )
	ENDPROC 



*!*	DRAWING IMAGES FUNCTIONS

	PROCEDURE DrawImage(tcFileName, tnX, tnY, tnWidth, tnHeight))
		IF PCOUNT() = 5 && Draw Image Scaled
			This.DrawImageScaled(tcFileName, tnX, tnY, tnWidth, tnHeight)
			RETURN 
		ENDIF 
		IF VARTYPE(m.tnX) + VARTYPE(m.tnY) <> 'NN' OR NOT VARTYPE(m.tcFileName) $ "CN"
			ERROR 11 && function argument
		ENDIF 
		LOCAL lnPasteImage
		IF VARTYPE(m.tcFileName) = "C"  && Image file to load
			lnPasteImage = 0
			This.stat = GdipLoadImageFromFile(This.WideStr(tcFileName), @lnPasteImage)
		ELSE && Use other image handle
			lnPasteImage = tcFileName
		ENDIF 
		This.stat = GdipDrawImage(This.getgraphics(), lnPasteImage, m.tnX, m.tnY)
		IF lnPasteImage <> This.NativeImage AND VARTYPE(m.tcFileName) = "C"  && Image file
			This.stat = GdipDisposeImage(lnPasteImage)
		ENDIF
	ENDPROC 
	
	PROCEDURE DrawImageScaled(tcFileName, tnX, tnY, tnWidth, tnHeight)
		IF VARTYPE(m.tnX) + VARTYPE(m.tnY) + VARTYPE(m.tnWidth) + VARTYPE(m.tnHeight) <> 'NNNN' ;
				OR NOT VARTYPE(m.tcFileName) $ "CN"
			ERROR 11 && function argument
		ENDIF
		IF VARTYPE(m.tcFileName) = "C"  && Image file to load
			lnPasteImage = 0
			This.stat = GdipLoadImageFromFile(This.WideStr(tcFileName), @lnPasteImage)
		ELSE && Use other image handle
			lnPasteImage = tcFileName
		ENDIF 
		This.stat = GdipDrawImageRect(This.getgraphics(), lnPasteImage, m.tnX, m.tnY, m.tnWidth, m.tnHeight)
		IF lnPasteImage <> This.NativeImage AND VARTYPE(m.tcFileName) = "C"  && Image file
			This.stat = GdipDisposeImage(lnPasteImage)
		ENDIF
	ENDPROC

	PROCEDURE DrawImageRectRect(tcFileName, ;
			dstx, dsty, dstwidth, dstheight, ;
			srcx, srcy, srcwidth, srcheight)

		IF VARTYPE(m.dstX) + VARTYPE(m.dstY) + VARTYPE(m.dstWidth) + VARTYPE(m.dstHeight) + ;
		   VARTYPE(m.srcX) + VARTYPE(m.srcY) + VARTYPE(m.srcWidth) + VARTYPE(m.srcHeight) <> 'NNNNNNNN' ;
		   		OR NOT VARTYPE(m.tcFileName) $ "CN"
			ERROR 11 && function argument
		ENDIF

		LOCAL lnPasteImage, nScrUnit, imageattribs
		IF VARTYPE(m.tcFileName) = "C"  && Image file to load
			lnPasteImage = 0
			This.stat = GdipLoadImageFromFile(This.WideStr(tcFileName), @lnPasteImage)
		ELSE && Use other image handle
			lnPasteImage = tcFileName
		ENDIF 

		imageAttribs = This.ImgAttribs
		SrcUnit = 2 && GraphicsUnit:Pixel
		This.Stat = GdipDrawImageRectRect(This.GetGraphics(), lnPasteImage, ;
			m.dstx, m.dsty, m.dstwidth, m.dstheight, ;
			m.srcx, m.srcy, m.srcwidth, m.srcheight, ;
			m.srcUnit, m.imageAttribs, 0, 0)
		
		IF lnPasteImage <> This.NativeImage AND VARTYPE(m.tcFileName) = "C"  && Image file
			This.stat = GdipDisposeImage(lnPasteImage)
		ENDIF
		
	ENDPROC 	



*!*	IMAGE ATTRIBUTES

	PROCEDURE SetColorMatrix(taColMatrix)
	*!*	The enableFlag parameter in the flat function is a Boolean value 
	*!*	that specifies whether a separate color adjustment is enabled for
	*!*	the category specified by the type parameter. SetColorMatrix sets
	*!*	enableFlag to TRUE, and ClearColorMatrix sets enableFlag to FALSE.

	*!*	The grayMatrix parameter specifies a matrix to be used for adjusting 
	*!*	gray shades when the value of the flags parameter is ColorMatrixFlagsAltGray.

		LOCAL lcColorMatrix
		lcColorMatrix = MakeColorMatrix(@taColMatrix)
		IF This.ImgAttribs <> 0
			This.DisposeImageAttributes(This.ImgAttribs)
		ENDIF 
		imageattr = 0
		This.Stat = GdipCreateImageAttributes(@imageattr)
		This.ImgAttribs = imageAttr

		This.Stat = GdipSetImageAttributesColorMatrix(ImageAttr, ;
			0, ;
			1, ;
			lcColorMatrix, ;
			0, ;
			0)
	ENDPROC 

	PROCEDURE RemapTable(tnOldColor, tnNewColor, tnOldAlpha, tnNewAlpha)
		LOCAL argbOld, argbNew, lcColorMap, imageattr

		IF PCOUNT() = 1 AND VARTYPE(tnOldColor) = "N" && Array of Colors is expected
			lcColorMap = MakeColorMap(@tnOldColor)			
		ELSE
			IF PCOUNT() = 2 && Ignore Alpha = 255 - opaque
				tnOldAlpha = 255
				tnNewAlpha = 255
			ENDIF 
			IF VARTYPE(tnOldColor) + VARTYPE(tnNewColor) <> "NN"
				ERROR 11
			ENDIF 

			argbOld = MakeARGB(tnOldColor, tnOldAlpha)
			argbNew = MakeARGB(tnNewColor, tnNewAlpha)
			lcColorMap = dword(argbOld) + dword(argbNew)
		ENDIF
		
		IF This.ImgAttribs <> 0
			This.DisposeImageAttributes(This.ImgAttribs)
		ENDIF 

		imageattr = 0
		This.Stat = GdipCreateImageAttributes(@imageattr)
		This.ImgAttribs = imageAttr
		This.Stat = GdipSetImageAttributesRemapTable(imageattr, 0 ,1, (LEN(lcColorMap)/4), lcColorMap)
	ENDPROC

	PROCEDURE DisposeImageAttributes(tnImgAttributes)
		This.Stat = GdipDisposeImageAttributes(tnImgAttributes)
		This.ImgAttribs = 0
	ENDPROC 

	PROCEDURE ResetImageAttributes(tnImgAttributes)
		This.Stat = GdipResetImageAttributes(tnImgAttributes, 0)
		This.ImgAttribs = 0
	ENDPROC 

	
	PROCEDURE ChangeColors(tnRed, tnGreen, tnBlue, tnAlpha)
		IF PCOUNT() = 1
			IF VARTYPE(tnRed) <> "N"
				ERROR 11
			ENDIF 
		ELSE
			IF (VARTYPE(tnRed) + VARTYPE(tnGreen) + VARTYPE(tnBlue) <> "NNN") ;
					OR (NOT VARTYPE(tnAlpha) $ "NL")
				ERROR 11
			ENDIF
		ENDIF 

		IF VARTYPE(tnAlpha) = "L"
			tnAlpha = 0
		ENDIF
		
		LOCAL lnWidth, lnHeight
		lnWidth  = 0
		lnHeight = 0
		This.stat = GdipGetImageWidth(This.nativeImage, @lnWidth)
		This.stat = GdipGetImageHeight(This.nativeImage, @lnHeight)

		IF PCOUNT() = 1
			This.SetPredefColorMatrix(tnRed)
		ELSE
			This.SetPredefColorMatrix(tnRed, tnGreen, tnBlue, tnAlpha)
		ENDIF
	
		This.DrawImageRectRect(This.NativeImage,0,0,lnWidth,lnHeight,0,0,lnWidth,lnHeight)
	ENDPROC 


	PROCEDURE SetPredefColorMatrix(tnRed, tnGreen, tnBlue, tnAlpha)
		*!*	Great information about COLOR MATRICES can be found at
		*!*	http://www.bobpowell.net/
		*!*	There I found all information I needed about COLOR MATRICES

		IF PCOUNT() = 1 && Predefined

			IF tnRed = 1 && BW
				*!*	BLACK AND WHITE IMAGE
				DIMENSION taBW(5,5)
				taBW(1,1) = 0.299
				taBW(1,2) = 0.299
				taBW(1,3) = 0.299
				taBW(1,4) = 0
				taBW(1,5) = 0
	
				taBW(2,1) = 0.587
				taBW(2,2) = 0.587
				taBW(2,3) = 0.587
				taBW(2,4) = 0
				taBW(2,5) = 0

				taBW(3,1) = 0.114
				taBW(3,2) = 0.114
				taBW(3,3) = 0.114
				taBW(3,4) = 0
				taBW(3,5) = 0

				taBW(4,1) = 0
				taBW(4,2) = 0
				taBW(4,3) = 0
				taBW(4,4) = 1
				taBW(4,5) = 0

				taBW(5,1) = 0
				taBW(5,2) = 0
				taBW(5,3) = 0
				taBW(5,4) = 0
				taBW(5,5) = 1
				This.SetColorMatrix(@taBW)
			ENDIF
	
			IF tnRed = 2 && Negative
				*!*	NEGATIVE IMAGE
				DIMENSION taNEGATIVE(5,5)
				taNEGATIVE(1,1) = -1
				taNEGATIVE(1,2) = 0
				taNEGATIVE(1,3) = 0
				taNEGATIVE(1,4) = 0
				taNEGATIVE(1,5) = 0

				taNEGATIVE(2,1) = 0
				taNEGATIVE(2,2) = -1
				taNEGATIVE(2,3) = 0
				taNEGATIVE(2,4) = 0
				taNEGATIVE(2,5) = 0

				taNEGATIVE(3,1) = 0
				taNEGATIVE(3,2) = 0
				taNEGATIVE(3,3) = -1
				taNEGATIVE(3,4) = 0
				taNEGATIVE(3,5) = 0

				taNEGATIVE(4,1) = 0
				taNEGATIVE(4,2) = 0
				taNEGATIVE(4,3) = 0
				taNEGATIVE(4,4) = 1
				taNEGATIVE(4,5) = 0

				taNEGATIVE(5,1) = 0
				taNEGATIVE(5,2) = 0
				taNEGATIVE(5,3) = 0
				taNEGATIVE(5,4) = 0
				taNEGATIVE(5,5) = 1
				This.SetColorMatrix(@taNEGATIVE)
			ENDIF
	
		ELSE
	
			*!*	CHANGE COLORS
			sr = tnRed / 100
			sg = tnGreen / 100
			sb = tnBlue / 100
			sa = tnAlpha / 100
 
			** create the color matrix
			DIMENSION taCUSTOM(5,5)
			taCUSTOM(1,1) = 1
			taCUSTOM(1,2) = 0
			taCUSTOM(1,3) = 0
			taCUSTOM(1,4) = 0
			taCUSTOM(1,5) = 0

			taCUSTOM(2,1) = 0
			taCUSTOM(2,2) = 1
			taCUSTOM(2,3) = 0
			taCUSTOM(2,4) = 0
			taCUSTOM(2,5) = 0

			taCUSTOM(3,1) = 0
			taCUSTOM(3,2) = 0
			taCUSTOM(3,3) = 1
			taCUSTOM(3,4) = 0
			taCUSTOM(3,5) = 0

			taCUSTOM(4,1) = 0
			taCUSTOM(4,2) = 0
			taCUSTOM(4,3) = 0
			taCUSTOM(4,4) = 1
			taCUSTOM(4,5) = 0

			taCUSTOM(5,1) = sr
			taCUSTOM(5,2) = sg
			taCUSTOM(5,3) = sb
			taCUSTOM(5,4) = sa
			taCUSTOM(5,5) = 1	
			This.SetColorMatrix(@taCUSTOM)
		ENDIF
	ENDPROC 


	PROCEDURE CreateFromGraphics(tnGraphics)
		DECLARE integer GdipGetClipBounds in gdiplus.dll ;
			integer nGraphics, string @ pRectF
		LOCAL lcRectF, nImage
		lcRectF = replicate(chr(0),16)
		This.Stat = GdipGetClipBounds (tnGraphics, @lcRectF )
		W = float2int(buf2dword(SUBSTR(m.lcRectF,9,4)))
		H = float2int(buf2dword(SUBSTR(m.lcRectF,13,4)))
		DECLARE integer GdipCreateBitmapFromGraphics in gdiplus.dll ;
			integer nWidth, integer nHeight, integer nGraphics, integer @ nImage

		*!*	this.Destroy()
		nImage = 0
		This.Stat = GdipCreateBitmapFromGraphics(m.W, m.H, tnGraphics, @nImage)
	ENDPROC 


	
	FUNCTION GetImage
		RETURN This.nativeImage
	ENDFUNC

	FUNCTION GetGraphics
		RETURN This.nativeGraphics
	ENDFUNC

	PROTECTED FUNCTION WideStr(tcStr)
#if Version(5) >= 700
		Return Strconv(tcStr + Chr(0), 5)
#else
		Local lnLen, lcWideStr
		lnLen = 2 * (Len(tcStr) + 1)
		lcWideStr = Replicate(Chr(0), lnLen)
		MultiByteToWideChar(0, 0, @tcStr, Len(tcStr), @lcWideStr, lnLen)
		Return lcWideStr
#endif
	ENDFUNC 




*!*	FUNCTIONS TO DEVELOP

	PROCEDURE FillRegion

*!*			DECLARE INTEGER GdipCreateRegion IN GdiPlus.dll ;
*!*				INTEGER @GpRegion
*!*			This.Stat = GdipCreateRegion(@region)

		DECLARE INTEGER GdipCreateRegionRect IN gdiplus.dll ;
			STRING cLayoutRect, INTEGER @GpRegion

		DECLARE INTEGER GdipFillRegion IN GdiPlus.dll ;
			INTEGER graphics, INTEGER nBrush, INTEGER GpRegion

		region = 0
		This.Stat = GdipCreateRegionRect(This.RectF, @region)
		This.Stat = GdipFillRegion(This.GetGraphics(), This.Brush, region)
	ENDPROC 
	
	PROCEDURE fillpath
		DECLARE INTEGER GdipCreatePath IN GdiPlus.dll ;
			INTEGER PathMode, INTEGER @GpRegion
		nPath = 0
		This.Stat = GdipCreatePath(1,@nPath)
	
		DECLARE INTEGER GdipFillPath IN gdiplus.dll ;
			INTEGER graphics, INTEGER nBrush, INTEGER nPath
		This.Stat = GdipFillPath(This.GetGraphics(), This.Brush, nPath)	
	ENDPROC 

***

ENDDEFINE 


***********************************************************************
*   Class:	EncoderParameter
***********************************************************************

Define Class EncoderParameter as Custom
	*	class EncoderParameter
	*	{
	*	public:
	*		GUID    Guid;				// GUID of the parameter
	*		ULONG   NumberOfValues;		// Number of the parameter values
	*		ULONG   Type;				// Value type, like ValueTypeLONG  etc.
	*		VOID*   Value;				// A pointer to the parameter values
	*	}

	Protected ValuePtr
	Protected encoderParam

	Procedure Init(lcGuid, lnValue)
		If (Vartype(lcGuid) != 'C') or (Vartype(lnValue) != 'N')
			Error 11
		EndIf

		This.ValuePtr = LocalAlloc(LPTR, 4)
		If This.ValuePtr = 0
			Error 1149
		EndIf
*		Sys(2600, This.ValuePtr, 4, DWord(lnValue))
		Declare RtlMoveMemory in Win32API AS RtlCopyData ;
			Long DestNum, Long @ pVoidSource, Integer nLength
		RtlCopyData(This.ValuePtr, lnValue, 4)

		This.encoderParam = lcGuid + DWord(1) + DWord(4)
		This.encoderParam = This.encoderParam + DWord(This.ValuePtr)
	EndFunc

	Procedure Destroy
		LocalFree(This.ValuePtr)
	EndFunc

	Function GetString
		Return This.encoderParam
	EndFunc

EndDefine


***********************************************************************
* Global functions
***********************************************************************

Function DWord(lnValue)
	* Creates a DWORD (unsigned 32-bit) 4 byte STRING from a number
	Local byte(4)
	If lnValue < 0
		lnValue = lnValue + 4294967296
	EndIf
	byte(1) = lnValue % 256
	byte(2) = BitRShift(lnValue, 8) % 256
	byte(3) = BitRShift(lnValue, 16) % 256
	byte(4) = BitRShift(lnValue, 24) % 256
	Return Chr(byte(1))+Chr(byte(2))+Chr(byte(3))+Chr(byte(4))
EndFunc

Function ErrorInfo(tnStatus)
	Do Case
	Case tnStatus = 0
		Return "Ok"
	Case tnStatus = 1
		Return "Generic Error"
	Case tnStatus = 2
		Return "Invalid Parameter"
	Case tnStatus = 3
		Return "Out Of Memory"
	Case tnStatus = 4
		Return "Object Busy"
	Case tnStatus = 5
		Return "Insufficient Buffer"
	Case tnStatus = 6
		Return "Not Implemented"
	Case tnStatus = 7
		Return "Win32 Error"
	Case tnStatus = 8
		Return "Wrong State"
	Case tnStatus = 9
		Return "Aborted"
	Case tnStatus = 10
		Return "File Not Found"
	Case tnStatus = 11
		Return "Value Overflow"
	Case tnStatus = 12
		Return "Access Denied"
	Case tnStatus = 13
		Return "Unknown Image Format"
	Case tnStatus = 14
		Return "Font Family Not Found"
	Case tnStatus = 15
		Return "Font Style Not Found"
	Case tnStatus = 16
		Return "Not True Type Font"
	Case tnStatus = 17
		Return "Unsupported Gdiplus Version"
	Case tnStatus = 18
		Return "Gdiplus Not Initialized"
	Case tnStatus = 19
		Return "Property Not Found"
	Case tnStatus = 20
		Return "Property Not Supported"
	Otherwise
		Return "Unknown Error"
	EndCase
EndFunc


***
*** Functions added
***

FUNCTION POINTF(X,Y) && adapted from RECTF found in www.news2news.com 
	RETURN dword(Int2Float(X)) + dword(Int2Float(Y))
ENDFUNC 

FUNCTION RECTF(X,Y,WIDTH,HEIGHT) && found in www.news2news.com 
	RETURN dword(Int2Float(X)) + dword(Int2Float(Y)) +; 
		dword(Int2Float(width)) + dword(Int2Float(height))
ENDFUNC 

FUNCTION Int2Float(num) && By Anatoly Mogylevets - found in www.fox.wikis.com
* converts FoxPro numeric to 32-bit float form 
	#DEFINE REAL_BIAS 127 
	#DEFINE REAL_MANTISSA_SIZE 23 
	#DEFINE REAL_NEGATIVE 0x80000000 
	#DEFINE EXPONENT_MASK 0x7F800000 
	#DEFINE MANTISSA_MASK 0x7FFFFF 
	LOCAL sgn, exponent, mantissa 
	DO CASE 
	CASE num < 0 
		sgn = REAL_NEGATIVE 
		num = -num 
	CASE num > 0 
		sgn = 0 
	OTHERWISE 
		RETURN 0 
	ENDCASE 
	exponent = FLOOR(LOG(num)/LOG(2)) 
	mantissa = (num - 2^exponent)* 2^(REAL_MANTISSA_SIZE - exponent) 
	exponent = BITLSHIFT(exponent+REAL_BIAS, REAL_MANTISSA_SIZE) 
	RETURN BITOR(sgn, exponent, mantissa) 
ENDFUNC

FUNCTION MAKEARGB(tnColor, tnAlpha)  && Alexander GolovLev
	Local argb, red, green, blue
	blue = Bitrshift(Bitand(tnColor, 0x00FF0000), 16)
	green = Bitrshift(Bitand(tnColor, 0x0000FF00), 8)
	red = Bitand(tnColor, 0x000000FF)
	argb = blue + Bitlshift(green, 8) + Bitlshift(red, 16)
	If Vartype(tnAlpha) = 'N'
		argb = argb + Bitlshift(Bitand(tnAlpha, 0xFF), 24)
	Else
		argb = argb + Bitlshift(255, 24)
	ENDIF
	RETURN ARGB
ENDFUNC 

FUNCTION GetRed(tnColor)
	RETURN BITAND(tnColor, 0x000000FF)
ENDFUNC

FUNCTION GetGreen(tnColor)
	RETURN BITRSHIFT(BITAND(tnColor, 0x0000FF00), 8)
ENDFUNC

FUNCTION GetBlue(tnColor)
	RETURN BITRSHIFT(BITAND(tnColor, 0x00FF0000), 16)
ENDFUNC

FUNCTION Float2Int(num) && By Anatoly Mogylevets - found in www.fox.wikis.com
	* converts 32-bit float form to FoxPro numeric 
	LOCAL sgn, exponent, mantissa 
	sgn = IIF(BITTEST(num,31), -1,1) 
	exponent = BITRSHIFT(BITAND(num, EXPONENT_MASK),; 
	REAL_MANTISSA_SIZE) - REAL_BIAS 
	mantissa = BITAND(num,; 
	MANTISSA_MASK) / 2^(REAL_MANTISSA_SIZE-exponent) 
RETURN (2^exponent + mantissa) * sgn 

FUNCTION buf2dword(lcBuffer)  && found in www.fox.wikis.com
	RETURN ASC(SUBSTR(lcBuffer, 1,1)) + ;
		   ASC(SUBSTR(lcBuffer, 2,1)) * 256 +;
	       ASC(SUBSTR(lcBuffer, 3,1)) * 65536 +;
    	   ASC(SUBSTR(lcBuffer, 4,1)) * 16777216
ENDFUNC

FUNCTION MakePointsFSequence(taIntPoints)
*** Creates a String containing all PointsF of the received array
	EXTERNAL ARRAY taIntPoints
	LOCAL lcPointsFSequence, lcPointF, n
	lcPointsFSequence = ""
	FOR n = 1 TO ALEN(taIntPoints,1)
		lcPointF = PointF(taIntPoints(n,1), taIntPoints(n,2))
		lcPointsFSequence = lcPointsFSequence + lcPointF
	ENDFOR
	RETURN lcPointsFSequence
ENDFUNC 

FUNCTION MakeColorMatrix(taColMatrix)
*** Creates a String containing ColorMatrix from the 5x5 received array
	EXTERNAL ARRAY taColMatrix
	LOCAL lcColorMatrix, nRow, nCol
	lcMatrix = ""
	FOR nRow = 1 TO 5
		FOR nCol = 1 TO 5
			lcMatrix = lcMatrix + dword(Int2Float(taColMatrix(nRow, nCol)))
		ENDFOR 
	ENDFOR
	RETURN lcMatrix
ENDFUNC

FUNCTION MakeColorMap(taColorMap)
*** Creates a String containing ColorMapt from the 4 column Array
	EXTERNAL ARRAY taColorMatrix
	LOCAL lcColorMap, n, lnArgbOld, lnArgbNew
	lcColorMap = ""
	FOR n = 1 TO ALEN(taColorMap,1)
		lnargbOld = MakeARGB(taColorMap(n,1), taColorMap(n,3))
		lnargbNew = MakeARGB(taColorMap(n,2), taColorMap(n,4))
		lcColorMap = lcColorMap + dword(lnargbOld) + dword(lnargbNew)
	ENDFOR
	RETURN lcColorMap
ENDFUNC